﻿#include "mainwindow.h"

#include <QApplication>

#include <plugins/CA_UiFrame/UiFrame.h>
#include <utils/ServiceRegistry.h>
#include <plugins/CA_ProjectManager/ProjectManager.h>
#include <plugins/CA_Visualization/Visualization.h>
#include <plugins/CA_Output/OutputWidget.h>
#include <plugins/CA_Visualization/VisualWidget.h>
#include <plugins/CA_PreProcessing/PreProcessing.h>
#include <plugins/CA_PostProcessing/PostProcessing.h>
#include <plugins/CA_MaterialSetting/MaterialManager.h>
#include <plugins/CA_PhysicalField/PhysicalField.h>
#include <plugins/CA_Slover/Slover.h>

VTK_MODULE_INIT(vtkRenderingFreeType);
VTK_MODULE_INIT(vtkRenderingOpenGL2);
VTK_MODULE_INIT(vtkInteractionStyle);

int main(int argc, char *argv[])
{
    QApplication a(argc, argv);
    QApplication::setWindowIcon(QIcon(":/resources/icon.png"));
    UiFrame uiFrame;

    ProjectManager projectManager;
    VisualWidget visualWidget;
    OutputWidget outputWidget;

    PreProcessing preProcessing;
    MaterialManager materialManager;
    PhysicalField physicalField;
    Slover slover;
    PostProcessing postProcessing;
    projectManager.expandTreeWidget();


    uiFrame.restoreState();
    uiFrame.show();
    return a.exec();
}
