﻿#include "FunctionWidget.h"
#include "ui_FunctionWidget.h"

#include <QScrollArea>

FunctionWidget::FunctionWidget(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::FunctionWidget)
{
    ui->setupUi(this);

    tmp();
}

FunctionWidget::~FunctionWidget()
{
    delete ui;
}

void FunctionWidget::tmp()
{
    ui->tableWidget->horizontalHeader()->setSectionResizeMode(0, QHeaderView::Stretch);
    ui->tableWidget->horizontalHeader()->setSectionResizeMode(1, QHeaderView::Stretch);

    ui->tableWidget_2->horizontalHeader()->setSectionResizeMode(0, QHeaderView::Stretch);
    ui->tableWidget_2->horizontalHeader()->setSectionResizeMode(1, QHeaderView::Stretch);
    QString buttonStyle = "QPushButton {"
                          "background-color: rgb(224, 233, 244);"
                          "border-width: 1px;"
                          "border-color: rgb(121, 121, 121);"
                          "border-style: solid;"
                          "height: 25px;"
                          "border-top: 1px solid rgb(169, 169, 169);" // 上边框为灰色
            "border-bottom: 1px solid rgb(169, 169, 169);" // 下边框为灰色
            "border-left: none;" // 移除左边框
            "border-right: none;"
            "text-align: left;"
            "}";
    ui->defineBtn->setStyleSheet(buttonStyle);
    ui->interpolationBtn->setStyleSheet(buttonStyle);
    ui->unitBtn->setStyleSheet(buttonStyle);

    // 创建图标
    QIcon icon(":/resources/btn_down.png");  // 替换为您的图标资源路径
    // 设置按钮的图标和文字布局
    ui->defineBtn->setIcon(icon);
    ui->defineBtn->setIconSize(QSize(16, 16));  // 设置图标大小
    ui->interpolationBtn->setIcon(icon);
    ui->interpolationBtn->setIconSize(QSize(16, 16));  // 设置图标大小
    ui->unitBtn->setIcon(icon);
    ui->unitBtn->setIconSize(QSize(16, 16));  // 设置图标大小
    m_definBtnstation = true;
    m_interpolationBtn = true;
    m_unitBtn = true;

    this->setStyleSheet(
                "QLabel {"
                "   font-family: \"Microsoft YaHei\", \"微软雅黑\";"
                "   font-size: 17px; "
                "   text-align: left;"
                "   color: rgb(51, 51, 51);"
                "   white-space: nowrap;"
                "   line-height: 50px;"
                "   position: absolute;"
                "   top: 0px;"
                "   left: 0px;"
                "}"
                );
    ui->label_2->setStyleSheet(""
                               "    font-size: 20px;"
                               "    font-family: \"Microsoft YaHei\", 微软雅黑;"
                               "    text-align: left;"
                               "    color: rgb(53, 103, 147);"
                               "");
    QString comboxStyle = ""
                          "QComboBox {"
                          "    font-family: \"Microsoft YaHei\", 微软雅黑;"
                          "   font-size: 17px; "
                          "    text-align: left;"
                          "   color: rgb(51, 51, 51);"
                          "    padding: 0px;"
                          "    background: rgb(240, 240, 240);"
                          "border: 1px solid rgb(169, 169, 169);"
                          "}"
                          "QComboBox::drop-down {background: rgb(240, 240, 240);}"
                          "}"
                          "QComboBox::down-arrow {"
                          "    image: url(:/resources/down_arrow.png);"
                          "}";
    ui->comboBox->setStyleSheet(comboxStyle);
    ui->comboBox_2->setStyleSheet(comboxStyle);
    ui->comboBox_3->setStyleSheet(comboxStyle);

    QString tableStyle = "QHeaderView::section {"
                         "    background-color: rgb(224, 233, 244);"
                         "    color: black;"
                         "    padding: 4px;"
                         "    border: 1px solid rgb(169, 169, 169);"
                         "    font-weight: bold; /* 设置字体加粗 */"
                         "}";

    ui->tableWidget->setStyleSheet(tableStyle);
    ui->tableWidget_2->setStyleSheet(tableStyle);

    QPixmap pixmap(":/resources/settingWidgetBtn/btn_add.png");
    ui->pushButton->setIcon(QIcon(pixmap));
    ui->pushButton->setIconSize(QSize(20, 20));
    ui->pushButton->setFixedSize(20, 20);

    QPixmap pixmap2(":/resources/settingWidgetBtn/btn_delete.png");
    ui->pushButton_2->setIcon(QIcon(pixmap2));
    ui->pushButton_2->setIconSize(QSize(20, 20));
    ui->pushButton_2->setFixedSize(20, 20);

    QPixmap pixmap3(":/resources/settingWidgetBtn/btn_clear.png");
    ui->pushButton_3->setIcon(QIcon(pixmap3));
    ui->pushButton_3->setIconSize(QSize(20, 20));
    ui->pushButton_3->setFixedSize(20, 20);

    QPixmap pixmap4(":/resources/settingWidgetBtn/btn_file.png");
    ui->pushButton_4->setIcon(QIcon(pixmap4));
    ui->pushButton_4->setIconSize(QSize(20, 20));
    ui->pushButton_4->setFixedSize(20, 20);

    QPixmap pixmap5(":/resources/settingWidgetBtn/btn_save.png");
    ui->pushButton_5->setIcon(QIcon(pixmap5));
    ui->pushButton_5->setIconSize(QSize(20, 20));
    ui->pushButton_5->setFixedSize(20, 20);

    {
        QPixmap pixmap(":/resources/settingWidgetBtn/btn_add.png");
        ui->pushButton_6->setIcon(QIcon(pixmap));
        ui->pushButton_6->setIconSize(QSize(20, 20));
        ui->pushButton_6->setFixedSize(20, 20);

        QPixmap pixmap2(":/resources/settingWidgetBtn/btn_delete.png");
        ui->pushButton_7->setIcon(QIcon(pixmap2));
        ui->pushButton_7->setIconSize(QSize(20, 20));
        ui->pushButton_7->setFixedSize(20, 20);

        QPixmap pixmap3(":/resources/settingWidgetBtn/btn_clear.png");
        ui->pushButton_8->setIcon(QIcon(pixmap3));
        ui->pushButton_8->setIconSize(QSize(20, 20));
        ui->pushButton_8->setFixedSize(20, 20);

        QPixmap pixmap4(":/resources/settingWidgetBtn/btn_file.png");
        ui->pushButton_9->setIcon(QIcon(pixmap4));
        ui->pushButton_9->setIconSize(QSize(20, 20));
        ui->pushButton_9->setFixedSize(20, 20);

        QPixmap pixmap5(":/resources/settingWidgetBtn/btn_save.png");
        ui->pushButton_10->setIcon(QIcon(pixmap5));
        ui->pushButton_10->setIconSize(QSize(20, 20));
        ui->pushButton_10->setFixedSize(20, 20);
    }

    ui->tableWidget->verticalHeader()->setVisible(false);
    ui->tableWidget->setRowCount(10);

    ui->tableWidget_2->verticalHeader()->setVisible(false);
    ui->tableWidget_2->setRowCount(10);

}

void FunctionWidget::on_defineBtn_clicked()
{
    if(m_definBtnstation)
    {
        // 创建图标
        QIcon icon(":/resources/btn_up.png");  // 替换为您的图标资源路径

        // 设置按钮的图标和文字布局
        ui->defineBtn->setIcon(icon);
        ui->defineBtn->setIconSize(QSize(16, 16));  // 设置图标大小
        ui->defineWidget->setVisible(false);
        m_definBtnstation = false;
    }
    else
    {
        // 创建图标
        QIcon icon(":/resources/btn_down.png");  // 替换为您的图标资源路径

        // 设置按钮的图标和文字布局
        ui->defineBtn->setIcon(icon);
        ui->defineBtn->setIconSize(QSize(16, 16));  // 设置图标大小
        ui->defineWidget->setVisible(true);
        m_definBtnstation = true;
    }
}


void FunctionWidget::on_interpolationBtn_clicked()
{
    if(m_interpolationBtn)
    {
        // 创建图标
        QIcon icon(":/resources/btn_up.png");  // 替换为您的图标资源路径

        // 设置按钮的图标和文字布局
        ui->interpolationBtn->setIcon(icon);
        ui->interpolationBtn->setIconSize(QSize(16, 16));  // 设置图标大小
        ui->interpolationWidget->setVisible(false);
        m_interpolationBtn = false;
    }
    else
    {
        // 创建图标
        QIcon icon(":/resources/btn_down.png");  // 替换为您的图标资源路径

        // 设置按钮的图标和文字布局
        ui->interpolationBtn->setIcon(icon);
        ui->interpolationBtn->setIconSize(QSize(16, 16));  // 设置图标大小
        ui->interpolationWidget->setVisible(true);
        m_interpolationBtn = true;
    }

}


void FunctionWidget::on_unitBtn_clicked()
{
    if(m_unitBtn)
    {
        // 创建图标
        QIcon icon(":/resources/btn_up.png");  // 替换为您的图标资源路径

        // 设置按钮的图标和文字布局
        ui->unitBtn->setIcon(icon);
        ui->unitBtn->setIconSize(QSize(16, 16));  // 设置图标大小
        ui->unitWidget->setVisible(false);
        m_unitBtn = false;
    }
    else
    {
        // 创建图标
        QIcon icon(":/resources/btn_down.png");  // 替换为您的图标资源路径

        // 设置按钮的图标和文字布局
        ui->unitBtn->setIcon(icon);
        ui->unitBtn->setIconSize(QSize(16, 16));  // 设置图标大小
        ui->unitWidget->setVisible(true);
        m_unitBtn = true;
    }
}

