#include "ParameterWidget.h"
#include "ui_ParameterWidget.h"

#include <public/services/UiFrameService.h>

#include <QTreeWidgetItem>

#include <utils/ServiceRegistry.h>

#include <QDebug>
ParameterWidget::ParameterWidget(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::ParameterWidget)
{
    ui->setupUi(this);
    QString buttonStyle = "QPushButton {"
                          "background-color: rgb(224, 233, 244);"
                          "border-width: 1px;"
                          "border-color: rgb(121, 121, 121);"
                          "border-style: solid;"
                          "height: 25px;"
                          "border-top: 1px solid rgb(169, 169, 169);" // 上边框为灰色
            "border-bottom: 1px solid rgb(169, 169, 169);" // 下边框为灰色
            "border-left: none;" // 移除左边框
            "border-right: none;"
            "text-align: left;"
            "}";
    ui->pushButton->setStyleSheet(buttonStyle);
    // 创建图标
    QIcon icon(":/resources/btn_down.png");  // 替换为您的图标资源路径
    // 设置按钮的图标和文字布局
    ui->pushButton->setIcon(icon);
    ui->pushButton->setIconSize(QSize(16, 16));  // 设置图标大小

    QString tableStyle = "QHeaderView::section {"
                         "    background-color: rgb(224, 233, 244);"
                         "    color: black;"
                         "    padding: 4px;"
                         "    border: 1px solid rgb(169, 169, 169);"
                         "    font-weight: bold; /* 设置字体加粗 */"
                         "}";
    ui->label->setStyleSheet(""
                               "    font-size: 20px;"
                               "    font-family: \"Microsoft YaHei\", 微软雅黑;"
                               "    text-align: left;"
                               "    color: rgb(53, 103, 147);"
                               "");
    ui->tableWidget->horizontalHeader()->setSectionResizeMode(0, QHeaderView::Stretch);
    ui->tableWidget->horizontalHeader()->setSectionResizeMode(1, QHeaderView::Stretch);
    ui->tableWidget->horizontalHeader()->setSectionResizeMode(2, QHeaderView::Stretch);
    ui->tableWidget->horizontalHeader()->setSectionResizeMode(3, QHeaderView::Stretch);
    ui->tableWidget->setStyleSheet(tableStyle);
    ui->tableWidget->verticalHeader()->setVisible(false);
    ui->tableWidget->setRowCount(10);
    m_pushButton = true;
}

ParameterWidget::~ParameterWidget()
{
    delete ui;
}

void ParameterWidget::on_pushButton_clicked()
{
    if(m_pushButton)
    {
        // 创建图标
        QIcon icon(":/resources/btn_up.png");  // 替换为您的图标资源路径

        // 设置按钮的图标和文字布局
        ui->pushButton->setIcon(icon);
        ui->pushButton->setIconSize(QSize(16, 16));  // 设置图标大小
        ui->widget->setVisible(false);
        m_pushButton = false;
    }
    else
    {
        // 创建图标
        QIcon icon(":/resources/btn_down.png");  // 替换为您的图标资源路径

        // 设置按钮的图标和文字布局
        ui->pushButton->setIcon(icon);
        ui->pushButton->setIconSize(QSize(16, 16));  // 设置图标大小
        ui->widget->setVisible(true);
        m_pushButton = true;
    }
}

