#ifndef MATERIALMANAGER_H
#define MATERIALMANAGER_H

#include "ConstitutiveModelSettingWidget.h"
#include "HeterogeneousSettingWidget.h"
#include "MaterialManagerWidget.h"
#include "PhysicalParametersSettingWidget.h"
#include "StrengthSettingWidget.h"

#include <public/services/ProjectManagerService.h>
#include <public/services/UiFrameService.h>

class MaterialManager:public QObject
{
    Q_OBJECT
public:
    MaterialManager();
    void addMaterial(QString name, QString uuid);
    void removeAllMaterial();
private:
    void setupTreeWidget();

private:
    ProjectManagerService *m_projectManagerService;
    UiFrameService *m_uiFrameService;

//    StrengthSettingWidget *m_strengthSettingWidget;
//    PhysicalParametersSettingWidget *m_physicalParametersSettingWidget;
//    HeterogeneousSettingWidget *m_heterogeneousSettingWidget;
//    ConstitutiveModelSettingWidget *m_constitutiveModelSettingWidget;
    MaterialManagerWidget *m_materialManagerWidget;
    QTreeWidgetItem *m_rootItem;
};

#endif // MATERIALMANAGER_H
