#include "BoundarySettingWidget.h"
#include "PhysicalField.h"
#include "ui_BoundarySettingWidget.h"

BoundarySettingWidget::BoundarySettingWidget(PhysicalField *physicalField,QWidget *parent) :
    QWidget(parent),
    m_physicalField(physicalField),
    ui(new Ui::BoundarySettingWidget)
{
    ui->setupUi(this);
    m_boundarySetting = m_physicalField->getBoundarySetting();
    m_boundarySetting->setBoundarySettingStatus(0);


    // 连接信号到槽
    connect(ui->selectNode, &QRadioButton::toggled, this, &BoundarySettingWidget::onRadioButtonToggled);
    connect(ui->selectFace, &QRadioButton::toggled, this, &BoundarySettingWidget::onRadioButtonToggled);
}

BoundarySettingWidget::~BoundarySettingWidget()
{
    delete ui;
}

void BoundarySettingWidget::showEvent(QShowEvent *event)
{
    qDebug()<<QStringLiteral("开始边界设置");
    ui->selectNode->setChecked(true);
}

void BoundarySettingWidget::onRadioButtonToggled(bool checked)
{
    // Sender() 获取触发信号的对象
    QRadioButton *button = qobject_cast<QRadioButton*>(sender());

    if (button) {
        if (checked) {
            if(button->text() == QStringLiteral("位移约束"))
            {
                m_boundarySetting->setBoundarySettingStatus(1);
            }
            else
            {
                m_boundarySetting->setBoundarySettingStatus(2);
            }
        }
    }
}

void BoundarySettingWidget::hideEvent(QHideEvent *event)
{
    qDebug() << QStringLiteral("结束边界设置");

    //0-结束
    m_boundarySetting->setBoundarySettingStatus(0);

    QWidget::hideEvent(event);

}

void BoundarySettingWidget::update()
{
    QWidget::update();
    qDebug()<<"update BoundarySettingWidget";
}


void BoundarySettingWidget::on_setPointData_clicked()
{

}

