#ifndef BOUNDARYSETTINGWIDGET_H
#define BOUNDARYSETTINGWIDGET_H

#include "BoundarySetting.h"
#include "qdebug.h"
#include <QWidget>

class PhysicalField;
namespace Ui {
class BoundarySettingWidget;
}

class BoundarySettingWidget : public QWidget
{
    Q_OBJECT

public:
    explicit BoundarySettingWidget(PhysicalField *physicalField, QWidget *parent = nullptr);
    ~BoundarySettingWidget();

    void showEvent(QShowEvent *event) override;
    void hideEvent(QHideEvent *event) override;

private slots:
    void onRadioButtonToggled(bool checked);

    void on_setPointData_clicked();

public:
    void update();

private:
    Ui::BoundarySettingWidget *ui;
    PhysicalField *m_physicalField;
    BoundarySetting *m_boundarySetting;

};

#endif // BOUNDARYSETTINGWIDGET_H
