#ifndef DISPLACEMENTLIMITSETTINGWIDGET_H
#define DISPLACEMENTLIMITSETTINGWIDGET_H

#include "BoundarySetting.h"

#include <QWidget>

class PhysicalField;
namespace Ui {
class DisplacementLimitSettingWidget;
}

class DisplacementLimitSettingWidget : public QWidget
{
    Q_OBJECT

public:
    explicit DisplacementLimitSettingWidget(PhysicalField *physicalField, QWidget *parent = nullptr);
    ~DisplacementLimitSettingWidget();
    void showEvent(QShowEvent *event) override;
    void hideEvent(QHideEvent *event) override;
    void onShowModelRadioButtonToggled(bool checked);

    void onSelectModelToggled(bool checked);
    void radiusChange(int value);

    void showData(int id, bool enable[], double value[]);
private slots:
    void on_setPointData_clicked();

    void on_deletePointData_clicked();

    void on_clearSelectedButton_clicked();

    void on_batchSelectButton_clicked();

private:
    Ui::DisplacementLimitSettingWidget *ui;
    PhysicalField *m_physicalField;
    BoundarySetting *m_boundarySetting;
    VisualWidgetService *m_visualWidgetService;
    PreProcessingService *m_preProcessingService;

    vtkSmartPointer<vtkSphereSource> m_sphereSource;
    double m_radius;
};

#endif // DISPLACEMENTLIMITSETTINGWIDGET_H
