#ifndef DISTRIBUTEDLOADSETTINGWIDGET_H
#define DISTRIBUTEDLOADSETTINGWIDGET_H

#include "BoundarySetting.h"


#include <QWidget>

class PhysicalField;
namespace Ui {
class DistributedLoadSettingWidget;
}

class DistributedLoadSettingWidget : public QWidget
{
    Q_OBJECT

public:
    explicit DistributedLoadSettingWidget(PhysicalField *physicalField, QWidget *parent = nullptr);
    ~DistributedLoadSettingWidget();
    void showEvent(QShowEvent *event) override;
    void hideEvent(QHideEvent *event) override;

    void onShowModelRadioButtonToggled(bool checked);
    void onSelectModelToggled(bool checked);
    void showData(int id, bool enable[], double value[]);
private slots:
    void on_clearSelectedButton_clicked();

    void on_batchSelectButton_clicked();

    void on_setFaceData_clicked();

    void on_deleteFaceData_clicked();

private:
    Ui::DistributedLoadSettingWidget *ui;
    PhysicalField *m_physicalField;
    BoundarySetting *m_boundarySetting;
    PreProcessingService *m_preProcessingService;
};

#endif // DISTRIBUTEDLOADSETTINGWIDGET_H
