#ifndef PHYSICALFIELD_H
#define PHYSICALFIELD_H

#include "AnalysisTypeSettingWidget.h"
#include "BoundarySetting.h"
#include "BoundarySettingWidget.h"
#include "DisplacementLimitSettingWidget.h"
#include "DistributedLoadSettingWidget.h"
#include "ExcavateSettingWidget.h"
#include "StaticProblemsSettingWidget.h"

#include <public/services/PhysicalFieldService.h>
#include <public/services/ProjectManagerService.h>
#include <public/services/UiFrameService.h>

class PhysicalField:public QObject,public PhysicalFieldService
{
    Q_OBJECT
public:
    PhysicalField();
    BoundarySetting *getBoundarySetting();
    DisplacementLimitSettingWidget *getDisplacementLimitSettingWidget();
    DistributedLoadSettingWidget *getDistributedLoadSettingWidget();
private:
    void setupTreeWidget();

private:
    UiFrameService *m_uiFrameService;
    ProjectManagerService *m_projectManagerService;
    AnalysisTypeSettingWidget *m_analysisTypeSettingWidget;
    BoundarySettingWidget *m_boundarySettingWidget;
    StaticProblemsSettingWidget *m_staticProblemsSettingWidget;
    ExcavateSettingWidget *m_excavateSettingWidget;
    BoundarySetting *m_boundarySetting;
    DisplacementLimitSettingWidget *m_displacementLimitSettingWidget;
    DistributedLoadSettingWidget *m_distributedLoadSettingWidget;
};

#endif // PHYSICALFIELD_H
