#ifndef NEPHOGRAMSETTINGWIDGET_H
#define NEPHOGRAMSETTINGWIDGET_H

#include <QWidget>
#include <public/services/NephogramService.h>
#include <public/services/VisualWidgetService.h>

class PostProcessing;
namespace Ui {
class NephogramSettingWidget;
}

class NephogramSettingWidget : public QWidget
{
    Q_OBJECT

public:
    explicit NephogramSettingWidget(PostProcessing *postProcessing,QWidget *parent = nullptr);
    ~NephogramSettingWidget();

    void setNephogramType(std::vector<std::string> vec_ps);

protected slots:
    void CheckIndexChangedSignal2(int i);
private slots:
    void CheckIndexChangedSignal(int i);
    void on_radioButton_clicked();
    void on_radioButton_2_clicked();

private:
    Ui::NephogramSettingWidget *ui;
    PostProcessing *m_postProcessing;
    VisualWidgetService *m_visualWidgetService;
    int m_type;
    bool m_isFirstClick;
    void readFile();
};

#endif // NEPHOGRAMSETTINGWIDGET_H
