#ifndef POSTPROCESSING_H
#define POSTPROCESSING_H

#include "BisectSettingWidget.h"
#include "ExportSettingWidget.h"
#include "GraphSettingWidget.h"
#include "NephogramSettingWidget.h"
#include "SectionSettingWidget.h"
#include "VTKNodeScalar.h"
#include "VTKScalar.h"

#include <QObject>

#include <public/services/ProjectManagerService.h>
#include <public/services/UiFrameService.h>
#include <public/services/VisualWidgetService.h>

class PostProcessing:  public QObject
{
    Q_OBJECT
public:
    PostProcessing();
    void readUnitNephogram(std::vector<std::string> &vec_ps,std::string inputFilename);
    void readNodeNephogram(std::vector<std::string> &vec_ps,std::string inputFilename);

    void unitChange(int i);
    void nodeChange(int i);
private:
    void setupTreeWidget();


private:
    UiFrameService *m_uiFrameService;
    ProjectManagerService *m_projectManagerService;
    NephogramSettingWidget *m_nephogramSettingWidget;
    GraphSettingWidget *m_graphSettingWidget;
    SectionSettingWidget *m_sectionSettingWidget;
    BisectSettingWidget *m_bisectSettingWidget;
    ExportSettingWidget *m_exportSettingWidget;

    vtkSmartPointer<vtkUnstructuredGrid> m_grid;
    vtkSmartPointer<vtkActor> m_nephoGramActor;
    VisualWidgetService *m_visualWidgetService;
    vtkSmartPointer<vtkScalarBarActor> m_scalarBar;

    VTKScalar *m_vtkScalar;
    VTKNodeScalar *m_vtkNodeScalar;



};

#endif // POSTPROCESSING_H
