#include<iostream>

#include<vtkProperty.h>
#include<vtkDataSetMapper.h>
#include <vtkCubeAxesActor.h>
#include "postCubeAxes.h"

using namespace std;



postCubeAxes::postCubeAxes()
{
   m_cubeAxesActor = vtkSmartPointer<vtkCubeAxesActor>::New();
}

postCubeAxes::~postCubeAxes()
{

}

vtkSmartPointer<vtkCubeAxesActor> postCubeAxes::getActor()
{
    return m_cubeAxesActor;
}

void postCubeAxes::setCamera(vtkCamera* use_camera)
{
    m_cubeAxesActor->SetCamera(use_camera);
    return;
}

void postCubeAxes::setBounds(double bounds[6])
{
    m_cubeAxesActor->SetBounds(bounds);
    m_cubeAxesActor->SetXAxisRange(bounds[0], bounds[1]);
    m_cubeAxesActor->SetYAxisRange(bounds[2], bounds[3]);
    m_cubeAxesActor->SetZAxisRange(bounds[4], bounds[5]);
    return;
}

void postCubeAxes::initcubebox()
{
    //vtkSmartPointer<vtkNamedColors>color1 = vtkSmartPointer<vtkNamedColors>::New();
    //设置坐标轴线的宽度
    m_cubeAxesActor->GetXAxesLinesProperty()->SetLineWidth(1);
    m_cubeAxesActor->GetYAxesLinesProperty()->SetLineWidth(1);
    m_cubeAxesActor->GetZAxesLinesProperty()->SetLineWidth(1);
    //设置标题和标签文本的屏幕大小。默认值为10.0。
    m_cubeAxesActor->SetScreenSize(10);
    //指定标签与轴之间的距离。默认值为20.0。
    m_cubeAxesActor->SetLabelOffset(10);
    //显示坐标轴
    m_cubeAxesActor->SetVisibility(true);
    //指定一种模式来控制轴的绘制方式
    m_cubeAxesActor->SetFlyMode(0);
    //m_cubeAxesActor->SetFlyMode(vtkCubeAxesActor::FlyMode::VTK_FLY_OUTER_EDGES);
	
    //设置惯性因子，该惯性因子控制轴切换位置的频率（从一个轴跳到另一个轴）
    m_cubeAxesActor->SetInertia(1);
    //网格设置
    //开启x、y、z轴的网格线绘制
    m_cubeAxesActor->DrawXGridlinesOn();
    m_cubeAxesActor->DrawYGridlinesOn();
    m_cubeAxesActor->DrawZGridlinesOn();
    //设置x、y、z轴的内部网格线不绘制
    m_cubeAxesActor->SetDrawXInnerGridlines(false);
    m_cubeAxesActor->SetDrawYInnerGridlines(false);
    m_cubeAxesActor->SetDrawZInnerGridlines(false);
    //设置x、y、z轴网格线的颜色
    m_cubeAxesActor->GetXAxesGridlinesProperty()->SetColor(0.5, 0.5, 0.5);
    m_cubeAxesActor->GetYAxesGridlinesProperty()->SetColor(0.5, 0.5, 0.5);
    m_cubeAxesActor->GetZAxesGridlinesProperty()->SetColor(0.5, 0.5, 0.5);
    //指定网格线呈现的样式
    m_cubeAxesActor->SetGridLineLocation(2);
	
    //刻度的设置
    //不显示x、y、z轴的次刻度
    m_cubeAxesActor->XAxisMinorTickVisibilityOff();
    m_cubeAxesActor->YAxisMinorTickVisibilityOff();
    m_cubeAxesActor->ZAxisMinorTickVisibilityOff();
    //设置刻度标签的显示方式(参数1为false，刻度标签按0-200000显示；为true时，按0-200显示)
    m_cubeAxesActor->SetLabelScaling(true, 0, 0, 0);
    //设置刻度线显示的位置(内部、外部、两侧)
    m_cubeAxesActor->SetTickLocation(1);
    //m_cubeAxesActor->SetTickLocation(vtkCubeAxesActor::TickLocation::VTK_TICKS_OUTSIDE);
}














