#pragma once

#include <vtkActor.h>
#include <vtkDataSetMapper.h>
#include <vtkLookupTable.h>
#include <vtkScalarBarActor.h>
#include <vtkFloatArray.h>
#include <vector>

#include <vtkTableBasedClipDataSet.h>

class postFilterClip
{
public:
    postFilterClip();
    ~postFilterClip();
    
private:
    vtkSmartPointer<vtkActor> m_clip_actor;
    vtkSmartPointer<vtkDataSetMapper> m_mapper;
    vtkSmartPointer<vtkLookupTable> m_lut;
    vtkSmartPointer<vtkUnstructuredGrid> m_ungrid;
    vtkSmartPointer<vtkScalarBarActor> m_scalarBar;
     
private:
    void buildScalarBar();
    void buildLut();
    
    int m_cell_type;
    float m_bound_value[6];
    float m_x_range[2];
    float m_y_range[2];
    float m_z_range[2];
    
public:
    vtkSmartPointer<vtkActor> getActor();
    vtkSmartPointer<vtkLookupTable> getLut();
   
    void setUnstructuredGrid(vtkSmartPointer<vtkUnstructuredGrid> ungrid);
    void showProcess(int current_id);
    void initProcess(int cell_type=0);
    
    void setCellType(int cell_type);
    int getCellType()const{return m_cell_type;}
    
    float *getRangeX();
    float *getRangeY();
    float *getRangeZ();
       
    void updateUsePointData(int current_id,int plane_id,float actua_value,bool b_invert_value);
    void updateUseCellData(int current_id,int plane_id,float actua_value,bool b_invert_value);
    void update(int current_id,int plane_id,float actua_value,bool b_invert_value);
    
    //void updateMulti(int current_id,float contour_min_value,float contour_max_value,int contour_num);
    //void updateSingle(int current_id,float contour_value);
};
















