#pragma once

#include <vtkActor.h>
#include <vtkDataSetMapper.h>
#include <vtkLookupTable.h>
#include <vtkScalarBarActor.h>
#include <vtkFloatArray.h>
#include <vector>

class postFilterContour
{
public:
    postFilterContour();
    ~postFilterContour();
    
private:
    vtkSmartPointer<vtkActor> m_contour_actor;
    vtkSmartPointer<vtkDataSetMapper> m_mapper;
    vtkSmartPointer<vtkLookupTable> m_lut;
    vtkSmartPointer<vtkUnstructuredGrid> m_ungrid;
    vtkSmartPointer<vtkScalarBarActor> m_scalarBar;
     
private:
    void buildScalarBar();
    void buildLut();
    
public:
    vtkSmartPointer<vtkActor> getActor();
    vtkSmartPointer<vtkLookupTable> getLut();
   
    void setUnstructuredGrid(vtkSmartPointer<vtkUnstructuredGrid> ungrid);
    void showProcess(int current_id);
    void initProcess();
    
    void updateMulti(int current_id,float contour_min_value,float contour_max_value,int contour_num);
    void updateSingle(int current_id,float contour_value);
};
















