#pragma once

#include <vtkActor.h>
#include <vtkDataSetMapper.h>
#include <vtkLookupTable.h>
#include <vtkScalarBarActor.h>
#include <vtkFloatArray.h>
#include <vtkArrowSource.h>

#include <vtkMaskPoints.h>
#include <vtkGlyph3D.h>

#include <vector>

class postFilterGlyph
{
public:
    postFilterGlyph();
    ~postFilterGlyph();
    
private:
    vtkSmartPointer<vtkActor> m_vec_actor;
    vtkSmartPointer<vtkDataSetMapper> m_mapper;
    vtkSmartPointer<vtkLookupTable> m_lut;
    vtkSmartPointer<vtkUnstructuredGrid> m_ungrid;
    vtkSmartPointer<vtkScalarBarActor> m_scalarBar;
    vtkSmartPointer<vtkArrowSource> m_arrow;
    
    vtkSmartPointer<vtkGlyph3D> m_glyph;
    vtkSmartPointer<vtkMaskPoints> m_mask;
    
    vtkSmartPointer<vtkFloatArray> m_vectors_disp;
    vtkSmartPointer<vtkFloatArray> m_vectors_s;

    //0 none 1 disp_vector 2 s_vector 3 disp_vector and s_vector
    int m_type;
   
    std::string m_name1;
    std::string m_name2;
    float m_max_scale;
    float m_show_scale;
        
    int m_mask_interval;
    int m_vector_type;
     
private:
    void buildScalarBar();
    void buildLut();
    
public:
    vtkSmartPointer<vtkActor> getActor();
    vtkSmartPointer<vtkLookupTable> getLut();
   
    void readScalarFile();
    int getVecType(std::vector<std::string>& m_vec_array_name);
    void setUnstructuredGrid(vtkSmartPointer<vtkUnstructuredGrid> ungrid);
    void calMaxScale();
    int getVecType()const{return m_vector_type;}
    void calVecType(std::vector<std::string>& m_vec_array_name);
    float getMaxScale()const{return m_max_scale;}
    
    float getShowScale()const{return m_show_scale;}
    void setShowScale(float show_scale);

    int getMaskInterval()const{return m_mask_interval;}
    void setMaskInterval(int mask_interval);
    
    void updateMaskInterval(int mask_interval);
    void update(float show_scale,int mask_interval);
    void updateShowScale(float show_scale);
    
    std::string getVecName1()const{return m_name1;}
    std::string getVecName2()const{return m_name2;}
    
    void showProcess(std::string show_name = "disp_vector");
    void initProcess();
};
















