#include<iostream>

#include<vtkProperty.h>
#include<vtkDataSetMapper.h>
#include<vtkUnstructuredGrid.h>
#include<vtkMultiBlockDataSet.h>
#include<vtkPointData.h>
#include<vtkCellData.h>
#include<vtkDataArray.h>
#include<vtkFloatArray.h>
#include<vtkPlane.h>
#include<vtkCutter.h>
#include<vtkNamedColors.h>
#include "postFilterSlice.h"

using namespace std;

postFilterSlice::postFilterSlice()
{
    m_slice_actor = vtkSmartPointer<vtkActor>::New();
    m_slice_main_actor = vtkSmartPointer<vtkActor>::New();
    m_mapper = vtkSmartPointer<vtkDataSetMapper>::New();
    m_mapper2 = vtkSmartPointer<vtkDataSetMapper>::New();
    m_lut = vtkSmartPointer<vtkLookupTable>::New();
    m_scalarBar = vtkSmartPointer<vtkScalarBarActor>::New();
    m_ungrid = vtkSmartPointer<vtkUnstructuredGrid>::New();
    m_ungrid2 = vtkSmartPointer<vtkUnstructuredGrid>::New();
    
    m_cell_type = 0;
    m_x_range[2] = {};
    m_y_range[2] = {};
    m_z_range[2] = {};
    m_bound_value[6] = {};
    
    m_point_opacity=1.0;
    m_point_size=20;
    m_point_color_x=1.0;
    m_point_color_y=0.0;
    m_point_color_z=0.0;
    
    this->buildLut();
    this->buildScalarBar();
}

postFilterSlice::~postFilterSlice()
{

}
void postFilterSlice::setUnstructuredGrid(vtkSmartPointer<vtkUnstructuredGrid> ungrid)
{
    m_ungrid->DeepCopy(ungrid);
    m_ungrid2->DeepCopy(ungrid);
    return;
}

void postFilterSlice::showProcess(int current_id,int use_point)
{
    if(use_point==1)
        showProcessMulti(current_id);
    else
        showProcessSingle(current_id);
    return;
}

void postFilterSlice::showMainProcess(int current_id,int plane_id,float actual_value)
{
    if(m_cell_type==0)
    {
        vtkSmartPointer<vtkPlane> plane = vtkSmartPointer<vtkPlane>::New();
        plane->SetOrigin(0, 0, 0);
        if(plane_id==0)
            plane->SetNormal(1, 0, 0);
        else if(plane_id==1)
            plane->SetNormal(0, 1, 0);
        else if(plane_id==2)
            plane->SetNormal(0, 0, 1);
    
        int m_show_array_id = current_id;
        //vtkSmartPointer<vtkTableBasedClipDataSet> clip = vtkSmartPointer<vtkTableBasedClipDataSet>::New();
        //m_ungrid2->GetPointData()->SetActiveScalars(m_ungrid2->GetPointData()->GetArrayName(m_show_array_id));
        //vtkDataArray* array_scalar = m_ungrid2->GetPointData()->GetArray(m_show_array_id);
        ///double* range = array_scalar->GetRange();
        //std::cout<<range[0]<<std::endl;
        //std::cout<<range[1]<<std::endl;
        
        vtkSmartPointer<vtkCutter> cutter = vtkSmartPointer<vtkCutter>::New();
        cutter->SetInputData(m_ungrid2);
        cutter->SetCutFunction(plane);
        cutter->SetValue(0,actual_value);
        cutter->Update();
        
        m_mapper2->SetInputData(cutter->GetOutput());
        m_mapper2->ScalarVisibilityOff();
        //m_mapper->SetLookupTable(m_lut);
        //m_mapper->SetScalarModeToUsePointFieldData();
        //m_mapper->SelectColorArray(m_ungrid2->GetPointData()->GetArrayName(m_show_array_id));
        //m_mapper->SetScalarRange(range); 

        //vtkNew<vtkNamedColors> colors;
        m_slice_main_actor->SetMapper(m_mapper2);
        m_slice_main_actor->GetProperty()->SetRepresentationToPoints();
        //m_slice_main_actor->GetProperty()->SetColor(colors->GetColor3d("Red").GetData());
        m_slice_main_actor->GetProperty()->SetColor(m_point_color_x,m_point_color_y,m_point_color_z);
        m_slice_main_actor->GetProperty()->RenderPointsAsSpheresOff();
        m_slice_main_actor->GetProperty()->SetPointSize(m_point_size);
    }
    else if(m_cell_type==1)
    {
        vtkSmartPointer<vtkPlane> plane = vtkSmartPointer<vtkPlane>::New();
        plane->SetOrigin(0, 0, 0);
        if(plane_id==0)
            plane->SetNormal(1, 0, 0);
        else if(plane_id==1)
            plane->SetNormal(0, 1, 0);
        else if(plane_id==2)
            plane->SetNormal(0, 0, 1);
    
        int m_show_array_id = current_id;
        //vtkSmartPointer<vtkTableBasedClipDataSet> clip = vtkSmartPointer<vtkTableBasedClipDataSet>::New();
        //m_ungrid2->GetPointData()->SetActiveScalars(m_ungrid2->GetPointData()->GetArrayName(m_show_array_id));
        //vtkDataArray* array_scalar = m_ungrid2->GetPointData()->GetArray(m_show_array_id);
        ///double* range = array_scalar->GetRange();
        //std::cout<<range[0]<<std::endl;
        //std::cout<<range[1]<<std::endl;
        
        vtkSmartPointer<vtkCutter> cutter = vtkSmartPointer<vtkCutter>::New();
        cutter->SetInputData(m_ungrid2);
        cutter->SetCutFunction(plane);
        cutter->SetValue(0,actual_value);
        cutter->Update();
        
        m_mapper2->SetInputData(cutter->GetOutput());
        m_mapper2->ScalarVisibilityOff();
        //m_mapper->SetLookupTable(m_lut);
        //m_mapper->SetScalarModeToUsePointFieldData();
        //m_mapper->SelectColorArray(m_ungrid2->GetPointData()->GetArrayName(m_show_array_id));
        //m_mapper->SetScalarRange(range); 

        //vtkNew<vtkNamedColors> colors;
        m_slice_main_actor->SetMapper(m_mapper2);
        m_slice_main_actor->GetProperty()->SetRepresentationToPoints();
        //m_slice_main_actor->GetProperty()->SetColor(colors->GetColor3d("Red").GetData());
        m_slice_main_actor->GetProperty()->SetColor(m_point_color_x,m_point_color_y,m_point_color_z);
        m_slice_main_actor->GetProperty()->RenderPointsAsSpheresOff();
        m_slice_main_actor->GetProperty()->SetPointSize(m_point_size);
    }
    return;
}

void postFilterSlice::showProcessMulti(int current_id)
{
    if(m_cell_type==0)
    {
        int m_show_array_id = current_id;
        vtkSmartPointer<vtkCutter> cutter = vtkSmartPointer<vtkCutter>::New();
        m_ungrid->GetPointData()->SetActiveScalars(m_ungrid->GetPointData()->GetArrayName(m_show_array_id));
        vtkDataArray* array_scalar = m_ungrid->GetPointData()->GetArray(m_show_array_id);
        double* range = array_scalar->GetRange();
        //std::cout<<range[0]<<std::endl;
        //std::cout<<range[1]<<std::endl;
        
        cutter->SetInputData(m_ungrid);
        //clip->SetInputData(grid);
        //clip->SetClipFunction(plane);
        //clip->InsideOutOn();
        //clip->GenerateClipScalarsOn();
        //clip->SetValue(15);
        //clip->Update();
   
        //double* range = m_ungrid->GetPointData()->GetArray(m_show_array_id)->GetRange();
    
        m_mapper->SetInputData(m_ungrid);
        m_mapper->SetLookupTable(m_lut);
        m_mapper->SetScalarModeToUsePointFieldData();
        m_mapper->SelectColorArray(m_ungrid->GetPointData()->GetArrayName(m_show_array_id));
        m_mapper->SetScalarRange(range); 

        m_slice_actor->SetMapper(m_mapper);
        //m_slice_main_actor->SetMapper(m_mapper);
    }
    else if(m_cell_type==1)
    {
        int m_show_array_id = current_id;
        m_ungrid->GetCellData()->SetActiveScalars(m_ungrid->GetCellData()->GetArrayName(m_show_array_id));
        vtkDataArray* array_scalar= m_ungrid->GetCellData()->GetArray(m_show_array_id);
        double* range = array_scalar->GetRange();

        vtkSmartPointer<vtkCutter> cutter = vtkSmartPointer<vtkCutter>::New();
        cutter->SetInputData(m_ungrid);
        //clip->SetClipFunction(plane);
        //clip->InsideOutOff();
        //clip->InsideOutOn();
        //clip->GenerateClipScalarsOn();
        //clip->SetValue(-0.01);
        //clip->SetValue(0);
        //clip->Update();

        m_mapper->SetInputData(m_ungrid);
        m_mapper->SetLookupTable(m_lut);
        m_mapper->SetScalarModeToUseCellFieldData();
        m_mapper->SelectColorArray(m_ungrid->GetCellData()->GetArrayName(m_show_array_id));
        m_mapper->SetScalarRange(range); // 强制使用LookupTable的范围
        
        m_slice_actor->SetMapper(m_mapper);
        //m_slice_main_actor->SetMapper(m_mapper);
    }
    return;
}

void postFilterSlice::showProcessSingle(int current_id)
{
    if(m_cell_type==0)
    {
        int m_show_array_id = current_id;
        vtkSmartPointer<vtkCutter> cutter = vtkSmartPointer<vtkCutter>::New();
        m_ungrid->GetPointData()->SetActiveScalars(m_ungrid->GetPointData()->GetArrayName(m_show_array_id));
        vtkDataArray* array_scalar = m_ungrid->GetPointData()->GetArray(m_show_array_id);
        double* range = array_scalar->GetRange();
        //std::cout<<range[0]<<std::endl;
        //std::cout<<range[1]<<std::endl;
        
        cutter->SetInputData(m_ungrid);
        //clip->SetInputData(grid);
        //clip->SetClipFunction(plane);
        //clip->InsideOutOn();
        //clip->GenerateClipScalarsOn();
        //clip->SetValue(15);
        //clip->Update();
   
        //double* range = m_ungrid->GetPointData()->GetArray(m_show_array_id)->GetRange();
    
        m_mapper->SetInputData(m_ungrid);
        m_mapper->SetLookupTable(m_lut);
        m_mapper->SetScalarModeToUsePointFieldData();
        m_mapper->SelectColorArray(m_ungrid->GetPointData()->GetArrayName(m_show_array_id));
        m_mapper->SetScalarRange(range); 

        m_slice_actor->SetMapper(m_mapper);
        //m_slice_main_actor->SetMapper(m_mapper);
    }
    else if(m_cell_type==1)
    {
        int m_show_array_id = current_id;
        m_ungrid->GetCellData()->SetActiveScalars(m_ungrid->GetCellData()->GetArrayName(m_show_array_id));
        vtkDataArray* array_scalar= m_ungrid->GetCellData()->GetArray(m_show_array_id);
        double* range = array_scalar->GetRange();

        vtkSmartPointer<vtkCutter> cutter = vtkSmartPointer<vtkCutter>::New();
        cutter->SetInputData(m_ungrid);
        //clip->SetClipFunction(plane);
        //clip->InsideOutOff();
        //clip->InsideOutOn();
        //clip->GenerateClipScalarsOn();
        //clip->SetValue(-0.01);
        //clip->SetValue(0);
        //clip->Update();

        m_mapper->SetInputData(m_ungrid);
        m_mapper->SetLookupTable(m_lut);
        m_mapper->SetScalarModeToUseCellFieldData();
        m_mapper->SelectColorArray(m_ungrid->GetCellData()->GetArrayName(m_show_array_id));
        m_mapper->SetScalarRange(range); // 强制使用LookupTable的范围
        
        m_slice_actor->SetMapper(m_mapper);
        //m_slice_main_actor->SetMapper(m_mapper);
    }
    return;
}

void postFilterSlice::updateSliceMulti(int current_id,int plane_id,float min_value,float max_value,int i_num)
{
    if(m_cell_type==0)
    {
        updateSliceMultiPoint(current_id,plane_id,min_value,max_value,i_num);
    }
    else if(m_cell_type==1)
    {
        updateSliceMultiCell(current_id,plane_id,min_value,max_value,i_num); 
    }
    return;
}

void postFilterSlice::updateSliceMultiPoint(int current_id,int plane_id,float min_value,float max_value,int i_num)
{
    vtkSmartPointer<vtkPlane> plane = vtkSmartPointer<vtkPlane>::New();
    plane->SetOrigin(0, 0, 0);
    if(plane_id==0)
        plane->SetNormal(1, 0, 0);
    else if(plane_id==1)
        plane->SetNormal(0, 1, 0);
    else if(plane_id==2)
        plane->SetNormal(0, 0, 1);
    
    int m_show_array_id = current_id;
    vtkSmartPointer<vtkTableBasedClipDataSet> clip = vtkSmartPointer<vtkTableBasedClipDataSet>::New();
    m_ungrid->GetPointData()->SetActiveScalars(m_ungrid->GetPointData()->GetArrayName(m_show_array_id));
    vtkDataArray* array_scalar = m_ungrid->GetPointData()->GetArray(m_show_array_id);
    double* range = array_scalar->GetRange();
    //std::cout<<range[0]<<std::endl;
    //std::cout<<range[1]<<std::endl;
        
    vtkSmartPointer<vtkCutter> cutter = vtkSmartPointer<vtkCutter>::New();
    cutter->SetInputData(m_ungrid);
    cutter->SetCutFunction(plane);
    cutter->GenerateValues(i_num, min_value, max_value);
    cutter->Update();

    m_mapper->SetInputData(cutter->GetOutput());
    m_mapper->SetLookupTable(m_lut);
    m_mapper->SetScalarModeToUsePointFieldData();
    m_mapper->SelectColorArray(m_ungrid->GetPointData()->GetArrayName(m_show_array_id));
    m_mapper->SetScalarRange(range); 

    m_slice_actor->SetMapper(m_mapper);

    return;
}

void postFilterSlice::updateSliceMultiCell(int current_id,int plane_id,float min_value,float max_value,int i_num)
{
    vtkSmartPointer<vtkPlane> plane = vtkSmartPointer<vtkPlane>::New();
    plane->SetOrigin(0, 0, 0);
    if(plane_id==0)
        plane->SetNormal(1, 0, 0);
    else if(plane_id==1)
        plane->SetNormal(0, 1, 0);
    else if(plane_id==2)
        plane->SetNormal(0, 0, 1);
    
    int m_show_array_id = current_id;
    vtkSmartPointer<vtkTableBasedClipDataSet> clip = vtkSmartPointer<vtkTableBasedClipDataSet>::New();
    m_ungrid->GetCellData()->SetActiveScalars(m_ungrid->GetCellData()->GetArrayName(m_show_array_id));
    vtkDataArray* array_scalar = m_ungrid->GetCellData()->GetArray(m_show_array_id);
    double* range = array_scalar->GetRange();
    //std::cout<<range[0]<<std::endl;
    //std::cout<<range[1]<<std::endl;
        
    vtkSmartPointer<vtkCutter> cutter = vtkSmartPointer<vtkCutter>::New();
    cutter->SetInputData(m_ungrid);
    cutter->SetCutFunction(plane);
    cutter->GenerateValues(i_num, min_value, max_value);
    cutter->Update();

    m_mapper->SetInputData(cutter->GetOutput());
    m_mapper->SetLookupTable(m_lut);
    m_mapper->SetScalarModeToUseCellFieldData();
    m_mapper->SelectColorArray(m_ungrid->GetCellData()->GetArrayName(m_show_array_id));
    m_mapper->SetScalarRange(range); 

    m_slice_actor->SetMapper(m_mapper);

    return;
}

void postFilterSlice::updateSliceSingle(int current_id,int plane_id,float actual_value)
{
    if(m_cell_type==0)
    {
        updateSliceSinglePoint(current_id,plane_id,actual_value);
    }
    else if(m_cell_type==1)
    {
        updateSliceSingleCell(current_id,plane_id,actual_value);
    }
    return;
}

void postFilterSlice::updateSliceSinglePoint(int current_id,int plane_id,float actual_value)
{
    vtkSmartPointer<vtkPlane> plane = vtkSmartPointer<vtkPlane>::New();
    plane->SetOrigin(0, 0, 0);
    if(plane_id==0)
        plane->SetNormal(1, 0, 0);
    else if(plane_id==1)
        plane->SetNormal(0, 1, 0);
    else if(plane_id==2)
        plane->SetNormal(0, 0, 1);
    
    int m_show_array_id = current_id;
    vtkSmartPointer<vtkTableBasedClipDataSet> clip = vtkSmartPointer<vtkTableBasedClipDataSet>::New();
    m_ungrid->GetPointData()->SetActiveScalars(m_ungrid->GetPointData()->GetArrayName(m_show_array_id));
    vtkDataArray* array_scalar = m_ungrid->GetPointData()->GetArray(m_show_array_id);
    double* range = array_scalar->GetRange();
    //std::cout<<range[0]<<std::endl;
    //std::cout<<range[1]<<std::endl;
        
    vtkSmartPointer<vtkCutter> cutter = vtkSmartPointer<vtkCutter>::New();
    cutter->SetInputData(m_ungrid);
    cutter->SetCutFunction(plane);
    cutter->SetValue(0,actual_value);
    cutter->Update();

    m_mapper->SetInputData(cutter->GetOutput());
    m_mapper->SetLookupTable(m_lut);
    m_mapper->SetScalarModeToUsePointFieldData();
    m_mapper->SelectColorArray(m_ungrid->GetPointData()->GetArrayName(m_show_array_id));
    m_mapper->SetScalarRange(range); 

    m_slice_actor->SetMapper(m_mapper);

    return;
}

void postFilterSlice::updateSliceSingleCell(int current_id,int plane_id,float actual_value)
{
    vtkSmartPointer<vtkPlane> plane = vtkSmartPointer<vtkPlane>::New();
    plane->SetOrigin(0, 0, 0);
    if(plane_id==0)
        plane->SetNormal(1, 0, 0);
    else if(plane_id==1)
        plane->SetNormal(0, 1, 0);
    else if(plane_id==2)
        plane->SetNormal(0, 0, 1);
    
    int m_show_array_id = current_id;
    vtkSmartPointer<vtkTableBasedClipDataSet> clip = vtkSmartPointer<vtkTableBasedClipDataSet>::New();
    m_ungrid->GetCellData()->SetActiveScalars(m_ungrid->GetCellData()->GetArrayName(m_show_array_id));
    vtkDataArray* array_scalar = m_ungrid->GetCellData()->GetArray(m_show_array_id);
    double* range = array_scalar->GetRange();
    //std::cout<<range[0]<<std::endl;
    //std::cout<<range[1]<<std::endl;
        
    vtkSmartPointer<vtkCutter> cutter = vtkSmartPointer<vtkCutter>::New();
    cutter->SetInputData(m_ungrid);
    cutter->SetCutFunction(plane);
    //cutter->GenerateValues(i_num, min_value, max_value);
    cutter->SetValue(0,actual_value);
    cutter->Update();

    m_mapper->SetInputData(cutter->GetOutput());
    m_mapper->SetLookupTable(m_lut);
    m_mapper->SetScalarModeToUseCellFieldData();
    m_mapper->SelectColorArray(m_ungrid->GetCellData()->GetArrayName(m_show_array_id));
    m_mapper->SetScalarRange(range); 

    m_slice_actor->SetMapper(m_mapper);
}

void postFilterSlice::update(int current_id,int plane_id,float actua_value,bool b_invert_value)
{
    if(m_cell_type==0)
    {
        updateUseCellData(current_id,plane_id,actua_value,b_invert_value);
    }
    else if(m_cell_type==1)
    {
        updateUseCellData(current_id,plane_id,actua_value,b_invert_value); 
    }
    return;
}

void postFilterSlice::updateUsePointData(int current_id,int plane_id,float actua_value,bool b_invert_value)
{
    vtkSmartPointer<vtkPlane> plane = vtkSmartPointer<vtkPlane>::New();
    plane->SetOrigin(0, 0, 0);
    if(plane_id==0)
        plane->SetNormal(1, 0, 0);
    else if(plane_id==1)
        plane->SetNormal(0, 1, 0);
    else if(plane_id==2)
        plane->SetNormal(0, 0, 1);
    
    int m_show_array_id = current_id;
    vtkSmartPointer<vtkTableBasedClipDataSet> clip = vtkSmartPointer<vtkTableBasedClipDataSet>::New();
    m_ungrid->GetPointData()->SetActiveScalars(m_ungrid->GetPointData()->GetArrayName(m_show_array_id));
    vtkDataArray* array_scalar = m_ungrid->GetPointData()->GetArray(m_show_array_id);
    double* range = array_scalar->GetRange();
    //std::cout<<range[0]<<std::endl;
    //std::cout<<range[1]<<std::endl;
        
    clip->SetInputData(m_ungrid);
    clip->SetClipFunction(plane);
    //clip->InsideOutOn();
    clip->SetInsideOut(b_invert_value);
    //clip->GenerateClipScalarsOn();
    clip->SetValue(actua_value);
    clip->Update();
   
    m_mapper->SetInputData(clip->GetOutput());
    m_mapper->SetLookupTable(m_lut);
    m_mapper->SetScalarModeToUsePointFieldData();
    m_mapper->SelectColorArray(m_ungrid->GetPointData()->GetArrayName(m_show_array_id));
    m_mapper->SetScalarRange(range); 

    m_slice_actor->SetMapper(m_mapper);

    return;
}

void postFilterSlice::updateUseCellData(int current_id,int plane_id,float actua_value,bool b_invert_value)
{
    vtkSmartPointer<vtkPlane> plane = vtkSmartPointer<vtkPlane>::New();
    plane->SetOrigin(0, 0, 0);
    if(plane_id==0)
        plane->SetNormal(1, 0, 0);
    else if(plane_id==1)
        plane->SetNormal(0, 1, 0);
    else if(plane_id==2)
        plane->SetNormal(0, 0, 1);
    
    int m_show_array_id = current_id;
    vtkSmartPointer<vtkTableBasedClipDataSet> clip = vtkSmartPointer<vtkTableBasedClipDataSet>::New();
    m_ungrid->GetCellData()->SetActiveScalars(m_ungrid->GetCellData()->GetArrayName(m_show_array_id));
    vtkDataArray* array_scalar = m_ungrid->GetCellData()->GetArray(m_show_array_id);
    double* range = array_scalar->GetRange();
    //std::cout<<range[0]<<std::endl;
    //std::cout<<range[1]<<std::endl;
        
    clip->SetInputData(m_ungrid);
    clip->SetClipFunction(plane);
    //clip->InsideOutOn();
    clip->SetInsideOut(b_invert_value);
    //clip->GenerateClipScalarsOn();
    clip->SetValue(actua_value);
    clip->Update();
   
    m_mapper->SetInputData(clip->GetOutput());
    m_mapper->SetLookupTable(m_lut);
    m_mapper->SetScalarModeToUseCellFieldData();
    m_mapper->SelectColorArray(m_ungrid->GetCellData()->GetArrayName(m_show_array_id));
    m_mapper->SetScalarRange(range); 

    m_slice_actor->SetMapper(m_mapper);

    return;
}

float * postFilterSlice::getRangeX()
{
    return m_x_range;
}

float * postFilterSlice::getRangeY()
{
    return m_y_range;
}

float * postFilterSlice::getRangeZ()
{
    return m_z_range;
}

void postFilterSlice::setCellType(int cell_type)
{
    m_cell_type = cell_type;
    return;
}

void postFilterSlice::initProcess(int cell_type)
{
    setCellType(cell_type);
    m_bound_value[0] = m_ungrid->GetBounds()[0];
    m_bound_value[1] = m_ungrid->GetBounds()[1];
    m_bound_value[2] = m_ungrid->GetBounds()[2];
    m_bound_value[3] = m_ungrid->GetBounds()[3];
    m_bound_value[4] = m_ungrid->GetBounds()[4];
    m_bound_value[5] = m_ungrid->GetBounds()[5];
    
    m_x_range[0] = m_ungrid->GetBounds()[0];
    m_x_range[1] = m_ungrid->GetBounds()[1];
    m_y_range[0] = m_ungrid->GetBounds()[2];
    m_y_range[1] = m_ungrid->GetBounds()[3];
    m_z_range[0] = m_ungrid->GetBounds()[4];
    m_z_range[1] = m_ungrid->GetBounds()[5];

    return;
}

void postFilterSlice::buildLut()
{
    // 创建一个色度图
    //vtkSmartPointer<vtkLookupTable> lut = vtkSmartPointer<vtkLookupTable>::New();
    m_lut->SetTableRange(-999, 999);
    m_lut->SetHueRange(0.67, 0.0);
    m_lut->Build();
    return;
}

void postFilterSlice::buildScalarBar()
{
    m_scalarBar->SetLookupTable(m_lut);
    m_scalarBar->SetTitle("CSRock");
    m_scalarBar->SetNumberOfLabels(5);
    m_scalarBar->SetPosition(0.9, 0.2);
    m_scalarBar->SetWidth(0.1);
    m_scalarBar->SetHeight(0.6);
    return;
}

vtkSmartPointer<vtkActor> postFilterSlice::getActor()
{
    return m_slice_actor;
}

vtkSmartPointer<vtkActor> postFilterSlice::getSliceMainActor()
{
    return m_slice_main_actor;
}

vtkSmartPointer<vtkLookupTable> postFilterSlice::getLut()
{
    return m_lut;
}

void postFilterSlice::updatePointColor(float color_x, float color_y, float color_z)
{
    m_slice_main_actor->GetProperty()->SetColor(color_x,color_y,color_z); 
}

void postFilterSlice::updatePointOpacity(float opacity)
{
    m_slice_main_actor->GetProperty()->SetOpacity(opacity);  
}
   
void postFilterSlice::updatePointSize(int point_size)
{
    m_slice_main_actor->GetProperty()->SetPointSize(point_size);      
}

void postFilterSlice::setPointOpacity(float opacity)
{
    m_point_opacity = opacity;
}

void postFilterSlice::setPointSize(int point_size)
{
    m_point_size = point_size;
}

void postFilterSlice::setPointColor(float color_x,float color_y,float color_z)
{
    m_point_color_x = color_x;
    m_point_color_y = color_y;
    m_point_color_z = color_z;
}
















