#pragma once

#include <vtkActor.h>
#include <vtkDataSetMapper.h>
#include <vtkLookupTable.h>
#include <vtkScalarBarActor.h>
#include <vtkFloatArray.h>
#include <vector>

class postFilterThreshold
{
public:
    postFilterThreshold();
    ~postFilterThreshold();
    
private:
    vtkSmartPointer<vtkActor> m_thr_actor;
    vtkSmartPointer<vtkDataSetMapper> m_mapper;
    vtkSmartPointer<vtkLookupTable> m_lut;
    vtkSmartPointer<vtkUnstructuredGrid> m_ungrid;
    vtkSmartPointer<vtkScalarBarActor> m_scalarBar;
     
private:
    void buildScalarBar();
    void buildLut();
    
    int m_cell_type;
    
public:
    vtkSmartPointer<vtkActor> getActor();
    vtkSmartPointer<vtkLookupTable> getLut();
   
    void setUnstructuredGrid(vtkSmartPointer<vtkUnstructuredGrid> ungrid);
    void showProcess(int current_id);
    void initProcess(int cell_type=0);
    
    void setCellType(int cell_type);
    int getCellType()const{return m_cell_type;}
    
    void updateUsePointData(int current_id,float actua_value_min,float actua_value_max,bool b_invert_value);
    void updateUseCellData(int current_id,float actua_value_min,float actua_value_max,bool b_invert_value);
    void update(int current_id,float actua_value_min,float actua_value_max,bool b_invert_value);
    
    //void updateMulti(int current_id,float contour_min_value,float contour_max_value,int contour_num);
    //void updateSingle(int current_id,float contour_value);
};
















