#include<iostream>
#include<fstream>
#include<string>
#include<sstream>
#include<vector> 
#include<algorithm>

#include "readCurveData.h"
using namespace std;

readCurveData::readCurveData()
{
    m_vec_data_name.clear();
    //vec_data_step.clear();
    m_vec_vec_data.clear();
    m_vec_max_data.clear();
    m_vec_min_data.clear();
    m_x_value_max=-1;
}

readCurveData::~readCurveData()
{

}

bool readCurveData::readCurveDataFile(std::string curve_data_file_name)
{
    m_vec_data_name.clear();
    //vec_data_step.clear();
    m_vec_vec_data.clear();
    m_vec_max_data.clear();
    m_vec_min_data.clear();
    
    ifstream ifs;
    ifs.open(curve_data_file_name.c_str(), std::ios::in);
    if(!ifs.is_open() )
    {
        cerr << "Error: Cannot open the file '" << curve_data_file_name << "'." << endl;
        return false;  
    }
    string line;
    std::getline(ifs, line);
    removeLineCarriage(&line);
    m_vec_data_name.clear();
    const char split_char = ' ';
    split(line,split_char,m_vec_data_name);
    
    m_vec_vec_data.resize(m_vec_data_name.size());
    while(std::getline(ifs, line))
    {
        istringstream iss(line);
        string tem;
        int count =0;
        while(iss >> tem)
        {
            m_vec_vec_data[count].push_back(atof(tem.c_str()));
            count +=1;
        }
    }
    
    if(m_vec_vec_data.size()<3)
    {
        return false;
    }
        
    if(m_vec_vec_data[0].size()<1)
    {
        return false;
    }
    
    m_x_value_max = int(m_vec_vec_data[0].back());

    for(int i=0;i<m_vec_vec_data.size();i++)
    {
        float max_value = *max_element(m_vec_vec_data[i].begin(), m_vec_vec_data[i].end());
        float min_value = *min_element(m_vec_vec_data[i].begin(), m_vec_vec_data[i].end());
        if(max_value-min_value<1e-5)
        {
            if(max_value>0)
                max_value = min_value*1.1;
            else if(max_value<0)
                min_value = max_value*1.1;
            else if (max_value-0<1e-5)
                max_value = 1.0;
        }
        m_vec_max_data.push_back(max_value);
        m_vec_min_data.push_back(min_value);
    }
    return true;
}

void readCurveData::split(const string &strtem, const char a, vector<string> &res)
{
    res.clear();
    string::size_type pos1, pos2;
    pos2 = strtem.find(a);
    pos1 = 0;
    while (string::npos != pos2)
    {
        res.push_back(strtem.substr(pos1, pos2 - pos1));
	pos1 = pos2 + 1;
	pos2 = strtem.find(a, pos1);
    }
    res.push_back(strtem.substr(pos1));
}

void readCurveData::removeLineCarriage(std::string *line)
{
    auto p = line->end() - 1;
    while ( (*p) == '\r' || (*p) == '\n' )
    {
        line->pop_back();
        p = line->end() - 1;
    }
}

int readCurveData::getStepValueMax()
{
    return m_x_value_max+1;
}
 
int readCurveData::getStepUseValueMax()
{
    return (m_x_value_max/10+1)*10;
}

vector<float>& readCurveData::getMaxValue()
{
    return m_vec_max_data;
}

vector<float>& readCurveData::getMinValue()
{
    return m_vec_min_data;
}

vector<vector<float>>& readCurveData::getData()
{ 
    return m_vec_vec_data;
}

vector<std::string>& readCurveData::getDataName()
{
    return m_vec_data_name;
}







