#include "ImportGridSettingWidget.h"
#include "PreProcessing.h"
#include "ui_ImportGridSettingWidget.h"

#include <QDir>
#include <QFileDialog>
#include <QDebug>

ImportGridSettingWidget::ImportGridSettingWidget(PreProcessing *preProcessing,QWidget *parent) :
    QWidget(parent),
    m_preProcessing(preProcessing),
    ui(new Ui::ImportGridSettingWidget)
{
    ui->setupUi(this);
}

ImportGridSettingWidget::~ImportGridSettingWidget()
{
    delete ui;
}

void ImportGridSettingWidget::on_pushButton_3_clicked()
{
    if(m_fileName == "")
        return;
    else
        m_preProcessing->importGrid(m_fileName);
}

//选文件地址
void ImportGridSettingWidget::on_pushButton_2_clicked()
{
    // 弹出文件选择对话框
    QFileDialog dialog(nullptr, QStringLiteral("选择 .nas 文件"));
    dialog.setNameFilter(QStringLiteral("NAS Files (*.nas)"));
    dialog.setFilter(QDir::Files);
    if (dialog.exec() == QDialog::Accepted) {
        m_fileName = dialog.selectedFiles().first();
    }

    // 如果用户选择了文件
    if (!m_fileName.isEmpty()) {
        // 在这里处理选择的文件路径 fileName
        ui->lineEdit->setText(m_fileName);
    }
}
