#pragma once

#include<vtkActor.h>
#include<vtkPolyData.h>

#include <iostream>

#include "structFromJson.h"

using namespace std;

class gen3DModel
{
public:
    gen3DModel();
    ~gen3DModel();
    
private:
    vtkSmartPointer<vtkActor> m_stl_actor;
    vtkSmartPointer<vtkPolyData> m_poly;
    
    float m_color_x;
    float m_color_y;
    float m_color_z;
    float m_opacity;
    
    //0 center leftBottom
    int m_offset_type;
    
    float m_length;
    float m_width;
    float m_height;
    float m_offset_x;
    float m_offset_y;
    float m_offset_z;
    
    //2 binary  1 ascii
    int m_write_file_type;

public:
    vtkSmartPointer<vtkActor> getActor();
    void setColor(float color_x, float color_y, float color_z);
    void setOpacity(float opacity);
    //void setStatusEdge(bool b_edge_on);
    float getOpacity()const{return m_opacity;}
    //bool getStatusEdge()const{return m_b_edge_on;}
    void update();
    void updateColor(float color_x, float color_y, float color_z);
    void updateOpacity(float opacity);
    //void updateStatusEdge(bool b_edge_on);
    
    float getOffsetType()const{return m_offset_type;}
    float getOffsetX()const{return m_offset_x;}
    float getOffsetY()const{return m_offset_y;}
    float getOffsetZ()const{return m_offset_z;}
    float getLength()const{return m_length;}
    float getWidth()const{return m_width;}
    float getHeight()const{return m_height;}
    
    void setOffsetType(int offset_type);
    void setOffsetTypeToCenter();
    void setOffsetTypeToLeftBottom();
    void setOffsetX(float offset_x);
    void setOffsetY(float offset_y);
    void setOffsetZ(float offset_z);
    void setLength(float length);
    void setWidth(float width);
    void setHeight(float height);
    
    void readJsonFile(string json_name);
    void writeJsonFile(string json_name);
    
    void genProcess();
    
    int getWriteFileMode()const{return m_write_file_type;}
    void setWriteFileMode(int write_file_type);
    void setWriteFileModeToAscii();
    void setWriteFileModeToBinary();
    void writeStlFile(string stl_file_name);
    
    void getModelParams(CasRockModel *struct_model);
    void setModelParams(CasRockModel *struct_model);
};
















