#pragma once

#include<iostream>
#include<fstream>
#include<string>
#include<vector>

#include<vtkActor.h>
#include<vtkPoints.h>
#include<vtkCellArray.h>
#include<vtkUnstructuredGrid.h>

using namespace std;

class readFlac
{
public:
    readFlac();
    ~readFlac();
    
private:
    vtkSmartPointer<vtkActor> m_actor;
    vtkSmartPointer<vtkUnstructuredGrid> m_grid;
    
    float m_color_x;
    float m_color_y;
    float m_color_z;
    float m_opacity;
    float m_line_width;
    
    //1 vtu 0 vtk
    int m_write_xml_type;
    //1 binary  0 ascii
    int m_write_data_type;
    
    int m_cell_type; //quad
    
    vector<float> vec_points;
    vector<float> vec_elements;
    
    bool endWith(const string &str, const string &tail);
    bool startWith(const string &str, const string &tail);
    void split(const string &strtem, const char a, vector<string> &res);
    void removeLineCarriage(std::string *line);
    
public:
    vtkSmartPointer<vtkActor> getActor();
    bool readFlacFile(string flac_file_name);
    
    void setColor(float color_x, float color_y, float color_z);
    void setOpacity(float opacity);    
    void setLineWidth(float line_width);
    
    float getOpacity()const{return m_opacity;}
    float getLineWidth()const{return m_line_width;}
    
    int getWriteDataMode()const{return m_write_data_type;}
    int getWriteXmlMode()const{return m_write_xml_type;}
    int getCellType()const{return m_cell_type;}
    
    void setWriteXmlMode(int write_xml_type);
    void setWriteDataMode(int write_data_type);
    void setWriteDataModeToAscii();
    void setWriteDataModeToBinary();
    void setWriteXmlModeToVtu();
    void setWriteXmlModeToVtk();
    
    void update();
    void updateColor(float color_x, float color_y, float color_z);
    void updateOpacity(float opacity);
    void updateLineWidth(float line_width);
    
    void writeFile(string file_name);
    void writeVtuFile(string vtu_file_name);
    void writeVtkFile(string vtk_file_name);
    
    void processVtkStruct();

    void writeGridFile(string nodes_file_name,string elements_file_name);
    void writeNodesFile(string nodes_file_name);
    void writeElementsFile(string elements_file_name);
};
















