#pragma once

#include<iostream>
#include<fstream>
#include<string>

#include<vtkActor.h>
#include<vtkPoints.h>
#include<vtkCellArray.h>
#include<vtkUnstructuredGrid.h>

using namespace std;

class readGrid
{
public:
    readGrid();
    ~readGrid();
    
private:
    vtkSmartPointer<vtkActor> m_actor;
    vtkSmartPointer<vtkUnstructuredGrid> m_grid;
    
    float m_color_x;
    float m_color_y;
    float m_color_z;
    float m_opacity;
    float m_line_width;
    
    //1 vtu 0 vtk
    int m_write_xml_type;
    //1 binary  0 ascii
    int m_write_data_type;
    
    bool buildVtkPoints(ifstream& nodes,  vtkSmartPointer<vtkPoints> points);
    bool buildVtkCells(ifstream& elements,  vtkSmartPointer<vtkCellArray> cells,vtkSmartPointer<vtkUnstructuredGrid> Grid);
    void buildQuadcells(int NElem, ifstream& elements,  vtkSmartPointer<vtkCellArray> cells, vtkSmartPointer<vtkUnstructuredGrid> Grid);
    void buildHexcells(int NElem, ifstream& elements,  vtkSmartPointer<vtkCellArray> cells, vtkSmartPointer<vtkUnstructuredGrid> Grid);
    
public:
    vtkSmartPointer<vtkActor> getActor();
    bool readGridFile(string nodepath,string elementpath);
    
    void setColor(float color_x, float color_y, float color_z);
    void setOpacity(float opacity);    
    void setLineWidth(float line_width);
    
    float getOpacity()const{return m_opacity;}
    float getLineWidth()const{return m_line_width;}
    
    int getWriteDataMode()const{return m_write_data_type;}
    int getWriteXmlMode()const{return m_write_xml_type;}
    
    void setWriteXmlMode(int write_xml_type);
    void setWriteDataMode(int write_data_type);
    void setWriteDataModeToAscii();
    void setWriteDataModeToBinary();
    void setWriteXmlModeToVtu();
    void setWriteXmlModeToVtk();
    
    void update();
    void updateColor(float color_x, float color_y, float color_z);
    void updateOpacity(float opacity);
    void updateLineWidth(float line_width);
    
    void writeFile(string file_name);
    void writeVtuFile(string vtu_file_name);
    void writeVtkFile(string vtk_file_name);
};
















