#include<iostream>
#include <fstream>
#include <sstream>
#include <string>

#include "readJson.h"

using namespace std;

readJson::readJson()
{

}

readJson::~readJson()
{

}

bool readJson::readModelJson(std::string json_name, CasRockModel* struct_model)
{
    auto findFloatValue = [this] (nlohmann::json &obj, const std::string &key, float &value) -> bool {
        if (!obj.contains(key))
            return false;
        value = obj[key].get<float>();
        return true;
    };
    
    auto findIntValue = [this] (nlohmann::json &obj, const std::string &key, int &value) -> bool {
        if (!obj.contains(key))
            return false;
        value = obj[key].get<int>();
        return true;
    };
    
    std::string json;
    std::stringstream ss;
    std::ifstream fin;
    fin.open(json_name, std::ios_base::in);
    if (!fin.is_open())
    {
        std::cout << "data.json open error" << std::endl;
        return false;
    }
    ss << fin.rdbuf();
    json = ss.str();
    
    nlohmann::json data;
    try {
        data = nlohmann::json::parse(json);
    } catch (std::exception &e) {
        return false;
    }catch (...) {
        return false;;
    }
    
    if (!data.is_object()) {
        return false;
    }
     
    int geo_type;
    int offset_type;
    float length;
    float width;
    float height;
    float offset_x;
    float offset_y;
    float offset_z;
    
    findIntValue(data, "geo_type", geo_type);
    findIntValue(data, "offset_type", offset_type);
    findFloatValue(data, "length", length);
    findFloatValue(data, "width", width);
    findFloatValue(data, "height", height);
    findFloatValue(data, "offset_x", offset_x);
    findFloatValue(data, "offset_y", offset_y);
    findFloatValue(data, "offset_z", offset_z); 
     
    struct_model->geo_type = geo_type;
    struct_model->offset_type = offset_type;
    struct_model->length = length;
    struct_model->width = width;
    struct_model->height = height;
    struct_model->offset_x = offset_x;
    struct_model->offset_y = offset_y;
    struct_model->offset_z = offset_z;
    
    fin.close();
    return true;
}


bool readJson::readGridJson(std::string json_name, CasRockGrid* struct_grid)
{
    auto findFloatValue = [this] (nlohmann::json &obj, const std::string &key, float &value) -> bool {
        if (!obj.contains(key))
            return false;
        value = obj[key].get<float>();
        return true;
    };
    
    auto findIntValue = [this] (nlohmann::json &obj, const std::string &key, int &value) -> bool {
        if (!obj.contains(key))
            return false;
        value = obj[key].get<int>();
        return true;
    };
    
    std::string json;
    std::stringstream ss;
    std::ifstream fin;
    fin.open(json_name, std::ios_base::in);
    if (!fin.is_open())
    {
        std::cout << "data.json open error" << std::endl;
        return false;
    }
    ss << fin.rdbuf();
    json = ss.str();
    
    nlohmann::json data;
    try {
        data = nlohmann::json::parse(json);
    } catch (std::exception &e) {
        return false;
    }catch (...) {
        return false;;
    }
    
    if (!data.is_object()) {
        return false;
    }
    
    int geo_type;
    int offset_type;
    float length;
    float width;
    float height;
    float offset_x;
    float offset_y;
    float offset_z;
    float max_interval_x;
    float max_interval_y;
    float max_interval_z;
    
    findIntValue(data, "geo_type", geo_type);
    findIntValue(data, "offset_type", offset_type);
    findFloatValue(data, "length", length);
    findFloatValue(data, "width", width);
    findFloatValue(data, "height", height);
    findFloatValue(data, "offset_x", offset_x);
    findFloatValue(data, "offset_y", offset_y);
    findFloatValue(data, "offset_z", offset_z);  
    findFloatValue(data, "max_interval_x", max_interval_x);
    findFloatValue(data, "max_interval_y", max_interval_y);
    findFloatValue(data, "max_interval_z", max_interval_z); 
    
    struct_grid->geo_type = geo_type;
    struct_grid->offset_type = offset_type;
    struct_grid->length = length;
    struct_grid->width = width;
    struct_grid->height = height;
    struct_grid->offset_x = offset_x;
    struct_grid->offset_y = offset_y;
    struct_grid->offset_z = offset_z;
    struct_grid->max_interval_x = max_interval_x;
    struct_grid->max_interval_y = max_interval_y;
    struct_grid->max_interval_z = max_interval_z;
    fin.close();
    return true;
}

bool readJson::writeModelJson(std::string json_name, CasRockModel* struct_model)
{
    std::ofstream fout(json_name.c_str());
    nlohmann::json j_model; 
    j_model["geo_type"]=struct_model->offset_type;
    j_model["offset_type"]=struct_model->offset_type;
    j_model["length"]=struct_model->length ;
    j_model["width"]=struct_model->width;
    j_model["height"]=struct_model->height;
    j_model["offset_x"]=struct_model->offset_x;
    j_model["offset_y"]=struct_model->offset_y;
    j_model["offset_z"]=struct_model->offset_z;
    fout<<std::setw(4)<<j_model<< std::endl;
    fout.close();
    return true;
}

bool readJson::writeGridJson(std::string json_name, CasRockGrid* struct_grid)
{
    std::ofstream fout(json_name.c_str());
    nlohmann::json j_grid; 
    j_grid["geo_type"]=struct_grid->offset_type;
    j_grid["offset_type"]=struct_grid->offset_type;
    j_grid["length"]=struct_grid->length ;
    j_grid["width"]=struct_grid->width;
    j_grid["height"]=struct_grid->height;
    j_grid["offset_x"]=struct_grid->offset_x;
    j_grid["offset_y"]=struct_grid->offset_y;
    j_grid["offset_z"]=struct_grid->offset_z;
    j_grid["max_interval_x"]=struct_grid->max_interval_x;
    j_grid["max_interval_y"]=struct_grid->max_interval_y;
    j_grid["max_interval_z"]=struct_grid->max_interval_z;
    fout<<std::setw(4)<<j_grid<< std::endl;
    fout.close();
    return true;
}
























