#include<iostream>

#include<vtkProperty.h>
#include<vtkActor.h>
#include<vtkDataSetMapper.h>
#include<vtkPolyData.h>
#include<vtkSTLReader.h>

#include "readSTL.h"
using namespace std;

readStl::readStl()
{
    m_stl_actor = vtkSmartPointer<vtkActor>::New();
    
    m_color_x = 0.75;
    m_color_y = 0.75;
    m_color_z = 0.75;
    m_opacity = 1.0;
}

readStl::~readStl()
{

}

void readStl::readStlFile(std::string file_name)
{
    vtkSmartPointer<vtkSTLReader>reader = vtkSmartPointer<vtkSTLReader>::New();
    reader->SetFileName(file_name.c_str());
    reader->Update();

    vtkSmartPointer<vtkPolyData> poly = vtkSmartPointer<vtkPolyData>::New();
    poly = reader->GetOutput();

    vtkSmartPointer<vtkDataSetMapper>mapper = vtkSmartPointer<vtkDataSetMapper>::New();
    mapper->SetInputData(poly);
    m_stl_actor->GetProperty()->EdgeVisibilityOff();
    m_stl_actor->SetMapper(mapper);
    m_stl_actor->GetProperty()->SetColor(m_color_x, m_color_y, m_color_z);
    m_stl_actor->GetProperty()->SetOpacity(m_opacity);
}

vtkSmartPointer<vtkActor> readStl::getActor()
{  
    return m_stl_actor;
}

void readStl::setColor(float color_x, float color_y, float color_z)
{  
    m_color_x = color_x;
    m_color_y = color_y;
    m_color_z = color_z;
}

void readStl::setOpacity(float opacity)
{  
    m_opacity =  opacity;
}

void readStl::update()
{  
    m_stl_actor->GetProperty()->SetColor(m_color_x, m_color_y, m_color_z);
    m_stl_actor->GetProperty()->SetOpacity(m_opacity);
}

void readStl::updateColor(float color_x, float color_y, float color_z)
{  
    m_stl_actor->GetProperty()->SetColor(color_x, color_y, color_z);
}

void readStl::updateOpacity(float opacity)
{  
    m_stl_actor->GetProperty()->SetOpacity(opacity);
}

















