#include<iostream>

#include<vtkProperty.h>
#include<vtkDataSetMapper.h>
#include<vtkUnstructuredGridReader.h>
#include<vtkUnstructuredGrid.h>

#include "readVtk.h"
using namespace std;

readVtk::readVtk()
{
    m_vtk_actor = vtkSmartPointer<vtkActor>::New();
    m_color_x = 0.75;
    m_color_y = 0.75;
    m_color_z = 0.75;
    m_opacity = 1.0;
    m_b_edge_on = true;
}

readVtk::~readVtk()
{

}

void readVtk::readVtkFile(std::string file_name)
{
    vtkSmartPointer<vtkUnstructuredGridReader>reader = vtkSmartPointer<vtkUnstructuredGridReader>::New();
    reader->SetFileName(file_name.c_str());
    reader->Update();

    vtkSmartPointer<vtkUnstructuredGrid> ungrid = vtkSmartPointer<vtkUnstructuredGrid>::New();
    ungrid = reader->GetOutput();

    vtkSmartPointer<vtkDataSetMapper>mapper = vtkSmartPointer<vtkDataSetMapper>::New();
    mapper->SetInputData(ungrid);
 
    m_vtk_actor->SetMapper(mapper);
    m_vtk_actor->GetProperty()->SetColor(m_color_x, m_color_y, m_color_z);
    m_vtk_actor->GetProperty()->SetOpacity(m_opacity);
    m_vtk_actor->GetProperty()->SetEdgeVisibility(m_b_edge_on);
}

vtkSmartPointer<vtkActor> readVtk::getActor()
{  
    return m_vtk_actor;
}

void readVtk::setColor(float color_x, float color_y, float color_z)
{  
    m_color_x = color_x;
    m_color_y = color_y;
    m_color_z = color_z;
}

void readVtk::setOpacity(float opacity)
{  
    m_opacity =  opacity;
}

void readVtk::setStatusEdge(bool b_edge_on)
{  
   m_b_edge_on = b_edge_on;
}

void readVtk::update()
{  
    m_vtk_actor->GetProperty()->SetColor(m_color_x, m_color_y, m_color_z);
    m_vtk_actor->GetProperty()->SetOpacity(m_opacity);
    m_vtk_actor->GetProperty()->SetEdgeVisibility(m_b_edge_on);
}

void readVtk::updateColor(float color_x, float color_y, float color_z)
{  
    m_vtk_actor->GetProperty()->SetColor(color_x, color_y, color_z);
}

void readVtk::updateOpacity(float opacity)
{  
    m_vtk_actor->GetProperty()->SetOpacity(opacity);
}

void readVtk::updateStatusEdge(bool b_edge_on)
{  
   m_vtk_actor->GetProperty()->SetEdgeVisibility(m_b_edge_on);
}

















