#include<iostream>

#include<vtkProperty.h>
#include<vtkDataSetMapper.h>
#include<vtkUnstructuredGridReader.h>
#include<vtkUnstructuredGrid.h>

#include "readVtkWireframe.h"

using namespace std;

readVtkWireframe::readVtkWireframe()
{
    m_vtk_actor = vtkSmartPointer<vtkActor>::New();
    m_color_x = 0.75;
    m_color_y = 0.75;
    m_color_z = 0.75;
    m_opacity = 1.0;
    m_line_width = 1.0;
}

readVtkWireframe::~readVtkWireframe()
{

}

void readVtkWireframe::readVtkFile(std::string file_name)
{
    vtkSmartPointer<vtkUnstructuredGridReader>reader = vtkSmartPointer<vtkUnstructuredGridReader>::New();
    reader->SetFileName(file_name.c_str());
    reader->Update();

    vtkSmartPointer<vtkUnstructuredGrid> ungrid = vtkSmartPointer<vtkUnstructuredGrid>::New();
    ungrid = reader->GetOutput();

    vtkSmartPointer<vtkDataSetMapper>mapper = vtkSmartPointer<vtkDataSetMapper>::New();
    mapper->SetInputData(ungrid);

    m_vtk_actor->SetMapper(mapper);
    m_vtk_actor->GetProperty()->SetColor(m_color_x, m_color_y, m_color_z);
    m_vtk_actor->GetProperty()->SetOpacity(m_opacity);
    m_vtk_actor->GetProperty()->SetLineWidth(m_line_width);
    m_vtk_actor->GetProperty()->SetRepresentationToWireframe();
}

vtkSmartPointer<vtkActor> readVtkWireframe::getActor()
{  
    return m_vtk_actor;
}

void readVtkWireframe::setColor(float color_x, float color_y, float color_z)
{  
    m_color_x = color_x;
    m_color_y = color_y;
    m_color_z = color_z;
}

void readVtkWireframe::setOpacity(float opacity)
{  
    m_opacity =  opacity;
}

void readVtkWireframe::setLineWidth(float line_width)
{  
    m_line_width = line_width;
}

void readVtkWireframe::update()
{  
    m_vtk_actor->GetProperty()->SetColor(m_color_x, m_color_y, m_color_z);
    m_vtk_actor->GetProperty()->SetOpacity(m_opacity);
    m_vtk_actor->GetProperty()->SetLineWidth(m_line_width);
}

void readVtkWireframe::updateColor(float color_x, float color_y, float color_z)
{  
    m_vtk_actor->GetProperty()->SetColor(color_x, color_y, color_z);
}

void readVtkWireframe::updateOpacity(float opacity)
{  
    m_vtk_actor->GetProperty()->SetOpacity(opacity);
}

void readVtkWireframe::updateLineWidth(float line_width)
{  
    m_vtk_actor->GetProperty()->SetLineWidth(line_width);
}

















