#include<iostream>

#include<vtkProperty.h>
#include<vtkDataSetMapper.h>
#include<vtkXMLUnstructuredGridReader.h>
#include<vtkUnstructuredGrid.h>

#include "readVtu.h"
using namespace std;

readVtu::readVtu()
{
    m_vtu_actor = vtkSmartPointer<vtkActor>::New();
    m_color_x = 0.75;
    m_color_y = 0.75;
    m_color_z = 0.75;
    m_opacity = 1.0;
    m_b_edge_on = true;
}

readVtu::~readVtu()
{

}

void readVtu::readVtuFile(std::string file_name)
{
    vtkSmartPointer<vtkXMLUnstructuredGridReader>reader = vtkSmartPointer<vtkXMLUnstructuredGridReader>::New();
    reader->SetFileName(file_name.c_str());
    reader->Update();

    vtkSmartPointer<vtkUnstructuredGrid> ungrid = vtkSmartPointer<vtkUnstructuredGrid>::New();
    ungrid = reader->GetOutput();

    vtkSmartPointer<vtkDataSetMapper>mapper = vtkSmartPointer<vtkDataSetMapper>::New();
    mapper->SetInputData(ungrid);
 
    m_vtu_actor->SetMapper(mapper);
    m_vtu_actor->GetProperty()->SetColor(m_color_x, m_color_y, m_color_z);
    m_vtu_actor->GetProperty()->SetOpacity(m_opacity);
    m_vtu_actor->GetProperty()->SetEdgeVisibility(m_b_edge_on);
}

vtkSmartPointer<vtkActor> readVtu::getActor()
{  
    return m_vtu_actor;
}

void readVtu::setColor(float color_x, float color_y, float color_z)
{  
    m_color_x = color_x;
    m_color_y = color_y;
    m_color_z = color_z;
}

void readVtu::setOpacity(float opacity)
{  
    m_opacity =  opacity;
}

void readVtu::setStatusEdge(bool b_edge_on)
{  
   m_b_edge_on = b_edge_on;
}

void readVtu::update()
{  
    m_vtu_actor->GetProperty()->SetColor(m_color_x, m_color_y, m_color_z);
    m_vtu_actor->GetProperty()->SetOpacity(m_opacity);
    m_vtu_actor->GetProperty()->SetEdgeVisibility(m_b_edge_on);
}

void readVtu::updateColor(float color_x, float color_y, float color_z)
{  
    m_vtu_actor->GetProperty()->SetColor(color_x, color_y, color_z);
}

void readVtu::updateOpacity(float opacity)
{  
    m_vtu_actor->GetProperty()->SetOpacity(opacity);
}

void readVtu::updateStatusEdge(bool b_edge_on)
{  
   m_vtu_actor->GetProperty()->SetEdgeVisibility(m_b_edge_on);
}

















