#include<iostream>

#include<vtkProperty.h>
#include<vtkDataSetMapper.h>
#include<vtkXMLUnstructuredGridReader.h>
#include<vtkUnstructuredGrid.h>

#include "readVtuWireframe.h"

using namespace std;

readVtuWireframe::readVtuWireframe()
{
    m_vtu_actor = vtkSmartPointer<vtkActor>::New();
    m_color_x = 0.75;
    m_color_y = 0.75;
    m_color_z = 0.75;
    m_opacity = 1.0;
    m_line_width = 1.0;
}

readVtuWireframe::~readVtuWireframe()
{

}

void readVtuWireframe::readVtuFile(std::string file_name)
{
    vtkSmartPointer<vtkXMLUnstructuredGridReader>reader = vtkSmartPointer<vtkXMLUnstructuredGridReader>::New();
    reader->SetFileName(file_name.c_str());
    reader->Update();

    vtkSmartPointer<vtkUnstructuredGrid> ungrid = vtkSmartPointer<vtkUnstructuredGrid>::New();
    ungrid = reader->GetOutput();

    vtkSmartPointer<vtkDataSetMapper>mapper = vtkSmartPointer<vtkDataSetMapper>::New();
    mapper->SetInputData(ungrid);

    m_vtu_actor->SetMapper(mapper);
    m_vtu_actor->GetProperty()->SetColor(m_color_x, m_color_y, m_color_z);
    m_vtu_actor->GetProperty()->SetOpacity(m_opacity);
    m_vtu_actor->GetProperty()->SetLineWidth(m_line_width);
    m_vtu_actor->GetProperty()->SetRepresentationToWireframe();
}

vtkSmartPointer<vtkActor> readVtuWireframe::getActor()
{  
    return m_vtu_actor;
}

void readVtuWireframe::setColor(float color_x, float color_y, float color_z)
{  
    m_color_x = color_x;
    m_color_y = color_y;
    m_color_z = color_z;
}

void readVtuWireframe::setOpacity(float opacity)
{  
    m_opacity =  opacity;
}

void readVtuWireframe::setLineWidth(float line_width)
{  
    m_line_width = line_width;
}

void readVtuWireframe::update()
{  
    m_vtu_actor->GetProperty()->SetColor(m_color_x, m_color_y, m_color_z);
    m_vtu_actor->GetProperty()->SetOpacity(m_opacity);
    m_vtu_actor->GetProperty()->SetLineWidth(m_line_width);
}

void readVtuWireframe::updateColor(float color_x, float color_y, float color_z)
{  
    m_vtu_actor->GetProperty()->SetColor(color_x, color_y, color_z);
}

void readVtuWireframe::updateOpacity(float opacity)
{  
    m_vtu_actor->GetProperty()->SetOpacity(opacity);
}

void readVtuWireframe::updateLineWidth(float line_width)
{  
    m_vtu_actor->GetProperty()->SetLineWidth(line_width);
}

















