#include "ProjectManager.h"
#include <QDebug>
#include <plugins/CA_ProjectManager/ProjectManagerWidget.h>
#include <utils/ServiceRegistry.h>

ProjectManager::ProjectManager()
{
    ServiceRegistry<ProjectManagerService>::instance().registerService(this);
    m_projectManagerWidget = new ProjectManagerWidget(this);
}

void ProjectManager::newProject()
{
    qDebug()<<"new";
}

void ProjectManager::openProject()
{
    qDebug()<<"open";
}

void ProjectManager::saveProject()
{
    qDebug()<<"save";
}

void ProjectManager::reSaveProject()
{
    qDebug()<<"resave";
}

void ProjectManager::addTreeItem(QTreeWidgetItem *treeItem)
{
    m_projectManagerWidget->addTreeItem(treeItem);
}

void ProjectManager::setItemWidget(QString uuid, QWidget *widget)
{
    m_projectManagerWidget->setItemWidget(uuid,widget);
}

void ProjectManager::setCurrentItem(QTreeWidgetItem *item)
{
    m_projectManagerWidget->setCurrentItem(item);
}

void ProjectManager::isDirty()
{

}

void ProjectManager::expandTreeWidget()
{
    m_projectManagerWidget->expandTreeWidget();
}

