#include "Slover.h"
#include <utils/ServiceRegistry.h>
#include <QProcess>
#include <QUuid>
#include <QDebug>
//#include <Windows.h>
#include <QToolButton>

Slover::Slover()
{
    m_projectManagerService = ServiceRegistry<ProjectManagerService>::instance().getService();
    m_uiFrameService = ServiceRegistry<UiFrameService>::instance().getService();
    setupTreeWidget();
}

void Slover::setupTreeWidget()
{
    //--------------求解器
    QToolButton *caculateSettingButton = new QToolButton;
    caculateSettingButton->setText(QStringLiteral("计算设置"));
    caculateSettingButton->setIcon(QIcon(":/resources/menu/caculateSetting.svg"));
    m_uiFrameService->addMenuButton(QStringLiteral("求解器"), "help", caculateSettingButton);

    m_calculateSettingWidget = new CalculateSettingWidget(this);
    QString uuid =  QUuid::createUuid().toString();
    QTreeWidgetItem *rootItem = new QTreeWidgetItem();
    rootItem->setText(0, QStringLiteral("求解器"));
    rootItem->setData(0, Qt::UserRole, uuid);
    m_projectManagerService->addTreeItem(rootItem);
    m_projectManagerService->setItemWidget(uuid,m_calculateSettingWidget);
    connect(caculateSettingButton, &QToolButton::clicked, [=]() {
            m_projectManagerService->setCurrentItem(rootItem);
    });

}

void Slover::startCaculate()
{
   /*
    QString program = "./solver/ParallelEPCA.exe"; // 替换为正确的路径

    QProcess *myProcess = new QProcess(this);
    myProcess->setWorkingDirectory("./solver"); // 设置工作目录为正确的路径

    // 设置启动选项，在 Windows 上使用 CREATE_NEW_CONSOLE 标志
    myProcess->setCreateProcessArgumentsModifier([](QProcess::CreateProcessArguments *args) {
            args->flags |= CREATE_NEW_CONSOLE;
            args->startupInfo->dwFlags &= ~STARTF_USESTDHANDLES;
        });

    myProcess->start(program);

    if (!myProcess->waitForStarted()) {
        qDebug() << "Failed to start process:" << myProcess->errorString();
        return;
    }

    qDebug() << "Process started successfully!";*/
}
