#ifndef SYSTEMBUTTONBAR_H
#define SYSTEMBUTTONBAR_H

#include <QHBoxLayout>
#include <QPushButton>
#include <QWidget>

class SystemButtonBar : public QWidget
{
    Q_OBJECT
public:
    SystemButtonBar();

    void setMaximized();
    void setRestored();

    void installOn(QWidget *widget);

    void setMinimizeButtonEnabled(bool enabled);
    void setMaximizeButtonEnabled(bool enabled);
    void setCloseButtonEnabled(bool enabled);

private:
    QString getTheme();

public slots:
    void onThemeChanged(const QString &theme);

protected slots:
    void onButtonMinimizeClicked();
    void onButtonMaximizeClicked();
    void onButtonRestoreClicked();
    void onButtonCloseClicked();

private:
    QPushButton *m_buttonMinimize;
    QPushButton *m_buttonMaximize;
    QPushButton *m_buttonClose;
    QPushButton *m_buttonRestore;

    QHBoxLayout *m_mainLayout;

    QWidget *m_widgetInstalledOn;
};

#endif // SYSTEMBUTTONBAR_H
