#ifndef TITLEWIDGET_H
#define TITLEWIDGET_H

#include <QHBoxLayout>
#include <QLabel>
#include <QMouseEvent>
#include <QWidget>

class UiFrame;
class SystemButtonBar;

class TitleWidget : public QWidget
{
    Q_OBJECT
private:
    void setupUi();
    void setupConnects();

protected:
    void mousePressEvent(QMouseEvent *event) override;
    void mouseReleaseEvent(QMouseEvent *event) override;
    void mouseDoubleClickEvent(QMouseEvent *event) override;
    void mouseMoveEvent(QMouseEvent *event) override;

public:
    void setLogo(const QPixmap &pixmap, const QSize &size);
    void setTitleText(const QString &titleText);

public:
    TitleWidget(UiFrame * uiFrame, QWidget *parent = nullptr);
private:
    UiFrame *m_uiFrame;

    QLabel *m_logoLabel;
    QLabel *m_titleLabel;
    QHBoxLayout *m_toolLayout;
    SystemButtonBar *m_systemButtonBar;

    QPoint m_pressPoint;
    bool m_isMove;

    QPoint m_movePoint;
    bool m_mousePressed;
};

#endif // TITLEWIDGET_H
