﻿#ifndef UIFRAME_H
#define UIFRAME_H

#include "TitleWidget.h"

#include <QMainWindow>
#include <QTreeWidget>
#include <DockManager.h>
#include <DockWidget.h>
#include <QVBoxLayout>
#include <public/services/UiFrameService.h>
#include <QHeaderView>
#include <QToolButton>
#include <plugins/CA_UiFrame/Ribbon.h>
class UiFrame: public QWidget , public UiFrameService
{
    Q_OBJECT
public:
    UiFrame();
    ~UiFrame();

    void addWidget(QWidget *widget, QString name);
    void restoreState();
    void setSettingWidget(QWidget *widget);
    void addMenuButton(QString tabName, QString groupName, QToolButton *button);
    void addFileButton(QPushButton *button);

private:
    QVBoxLayout *m_mainLayout;
    TitleWidget *m_titleWidget;
    QMainWindow *m_mainWindow;
    ads::CDockManager* m_dockManager;
    ads::CDockWidget *m_initDockWidget;

    ads::CDockWidget *m_settingDockWidget;
    Ribbon *m_ribbonTabWidget;

    void setupUi();

};

#endif // UIFRAME_H
