﻿#include "VisualWidget.h"
#include "ui_VisualWidget.h"

#include <utils/ServiceRegistry.h>



#include <public/services/NephogramService.h>

VisualWidget::VisualWidget(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::VisualWidget)
{
    ui->setupUi(this);
    m_uiFrameService = ServiceRegistry<UiFrameService>::instance().getService();
    ServiceRegistry<VisualWidgetService>::instance().registerService(this);

    setupButton();
    m_uiFrameService->addWidget(this,QStringLiteral("图形"));


    initVTKWidget();
    this->setStyleSheet(""
                        "background: rgb(255,255,255)");

    this->setFocus();

    m_scalarBar = nullptr;
    m_gridActor = nullptr;
}

void VisualWidget::setupButton()
{
    //    QPixmap pixmap(":/resources/VisualBtn/btn_magnify.png");
    //    ui->pushButton->setIcon(QIcon(pixmap));
    //    ui->pushButton->setIconSize(QSize(30, 30));
    //    ui->pushButton->setFixedSize(30, 30);

    //    QPixmap pixmap2(":/resources/VisualBtn/btn_shrink.png");
    //    ui->pushButton_2->setIcon(QIcon(pixmap2));
    //    ui->pushButton_2->setIconSize(QSize(30, 30));
    //    ui->pushButton_2->setFixedSize(30, 30);

    //    QPixmap pixmap3(":/resources/VisualBtn/btn_magnify2.png");
    //    ui->pushButton_3->setIcon(QIcon(pixmap3));
    //    ui->pushButton_3->setIconSize(QSize(30, 30));
    //    ui->pushButton_3->setFixedSize(30, 30);

    //    QPixmap pixmap4(":/resources/VisualBtn/btn_magnify3.png");
    //    ui->pushButton_4->setIcon(QIcon(pixmap4));
    //    ui->pushButton_4->setIconSize(QSize(30, 30));
    //    ui->pushButton_4->setFixedSize(30, 30);

    //    QPixmap pixmap5(":/resources/VisualBtn/btn_reposition.png");
    //    ui->pushButton_5->setIcon(QIcon(pixmap5));
    //    ui->pushButton_5->setIconSize(QSize(30, 30));
    //    ui->pushButton_5->setFixedSize(30, 30);

    //    QPixmap pixmap6(":/resources/VisualBtn/btn_grid.png");
    //    ui->pushButton_6->setIcon(QIcon(pixmap6));
    //    ui->pushButton_6->setIconSize(QSize(30, 30));
    //    ui->pushButton_6->setFixedSize(30, 30);

    //    QPixmap pixmap7(":/resources/VisualBtn/btn_Chromabar.png");
    //    ui->pushButton_7->setIcon(QIcon(pixmap7));
    //    ui->pushButton_7->setIconSize(QSize(30, 30));
    //    ui->pushButton_7->setFixedSize(30, 30);

    //    QPixmap pixmap8(":/resources/VisualBtn/btn_share.png");
    //    ui->pushButton_8->setIcon(QIcon(pixmap8));
    //    ui->pushButton_8->setIconSize(QSize(30, 30));
    //    ui->pushButton_8->setFixedSize(30, 30);

    //    QPixmap pixmap9(":/resources/VisualBtn/btn_Screenshot.png");
    //    ui->pushButton_9->setIcon(QIcon(pixmap9));
    //    ui->pushButton_9->setIconSize(QSize(30, 30));
    //    ui->pushButton_9->setFixedSize(30, 30);

    //   QPixmap pixmap10(":/resources/VisualBtn/btn_print.png");
    //    ui->pushButton_10->setIcon(QIcon(pixmap10));
    //    ui->pushButton_10->setIconSize(QSize(30, 30));
    //    ui->pushButton_10->setFixedSize(30, 30);
}

vtkSmartPointer<vtkRenderer> VisualWidget::getRender()
{
    return m_renderer;
}

vtkSmartPointer<vtkRenderWindow> VisualWidget::getrenderWindow()
{
    return m_renderWindow;
}

vtkSmartPointer<vtkRenderWindowInteractor> VisualWidget::getInteractor()
{
    return m_renderWindowInteractor;
}

void VisualWidget::initVTKWidget()
{
    m_renderer = vtkSmartPointer<vtkRenderer>::New();

    m_renderer->SetBackground(231.0 / 255.0, 242.0 / 255.0, 255.0 / 255.0);
    m_renderer->SetBackground2(1.0,1.0,1.0);
    m_renderer->SetGradientBackground(true);

    m_renderWindow = ui->vtkWidget->renderWindow();
    m_renderWindow->AddRenderer(m_renderer);

    m_renderWindowInteractor = ui->vtkWidget->interactor();
    m_renderWindowInteractor->SetRenderWindow(m_renderWindow);



    // 创建坐标轴
    // 创建一个坐标轴actor
    vtkSmartPointer<vtkAxesActor> axes = vtkSmartPointer<vtkAxesActor>::New();
    vtkOrientationMarkerWidget *orientationMarkerWidget =
            vtkOrientationMarkerWidget::New();
    orientationMarkerWidget->SetOutlineColor( 0.9300, 0.5700, 0.1300 );
    orientationMarkerWidget->SetOrientationMarker(axes);
    orientationMarkerWidget->SetInteractor(m_renderWindowInteractor);
    orientationMarkerWidget->SetViewport( 0.0, 0.0, 0.2, 0.2 ); // 调整大小和位置
    orientationMarkerWidget->SetEnabled(1);
    orientationMarkerWidget->InteractiveOff();

    if(m_mainActor != nullptr) m_renderer->RemoveActor(m_mainActor);

}
//读标量文件
//void VisualWidget::nephogramTypeIndexChanged(int i)
//{
//    std::cout<<i<<std::endl;
//    m_vtkScalar->change(i);
//    m_renderWindow->Render();
//}

void VisualWidget::addActor(vtkSmartPointer<vtkActor> actor)
{
    m_renderer->AddActor(actor);
    m_tmpActor.append(actor);
//    m_renderer->ResetCamera();
//    m_renderWindow->Render();
}

void VisualWidget::addActor2D(vtkSmartPointer<vtkActor2D> actor)
{
    m_renderer->AddActor2D(actor);
    m_scalarBar = actor;
    m_renderWindow->Render();
}

void VisualWidget::removeActor(vtkSmartPointer<vtkActor> actor)
{
    m_renderer->RemoveActor(actor);
}

void VisualWidget:: removeAllActor()
{
    for(int i=0; i<m_tmpActor.size(); i++)
    {
        m_renderer->RemoveActor(m_tmpActor[i]);
    }
    if(m_scalarBar!=nullptr) m_renderer->RemoveActor2D(m_scalarBar);
    m_scalarBar = nullptr;
    m_tmpActor.clear();
    m_renderWindow->Render();
}

void VisualWidget::removeGridActor(vtkSmartPointer<vtkActor> actor)
{
    if(m_gridActor != nullptr)
    {

    }
    m_gridActor = nullptr;
}

void VisualWidget::reFreash()
{
    m_renderWindow->Render();
}


VisualWidget::~VisualWidget()
{
    delete ui;
}

