#ifndef PREPROCESSINGSERVICE_H
#define PREPROCESSINGSERVICE_H


#include <QString>
#include <vtkActor.h>
#include <vtkPolyData.h>
#include <vtkSmartPointer.h>
#include <vtkSphereSource.h>
#include <vtkUnstructuredGrid.h>


struct PreProcessingService
{
    virtual vtkSmartPointer<vtkUnstructuredGrid> getGridStructure() = 0;
    virtual vtkSmartPointer<vtkUnstructuredGrid> getPointStructure() = 0;
    virtual bool is3DType() = 0;
    virtual QVector<QSet<int> > getFaceToPoint() = 0;
    virtual QVector<QVector<int> > getFaceToCell() = 0;
    virtual vtkSmartPointer<vtkActor> getPointActor() = 0;
    virtual QMap<int, int> getCellIdToGridIdMap() = 0;
    virtual vtkSmartPointer<vtkSphereSource> getSphereSource() = 0;
    virtual bool isHaveStructured() = 0;
};

#endif // PREPROCESSINGSERVICE_H
