#ifndef VISUALWIDGETSERVICE_H
#define VISUALWIDGETSERVICE_H

#include <vtkActor.h>
#include <vtkActor2D.h>
#include <vtkRenderWindowInteractor.h>
#include <vtkSmartPointer.h>

struct VisualWidgetService
{
    virtual void addActor(vtkSmartPointer<vtkActor> actor) = 0;
    virtual void addActor2D(vtkSmartPointer<vtkActor2D> actor) = 0;
    virtual void removeActor(vtkSmartPointer<vtkActor> actor) = 0;
    virtual void removeAllActor() = 0;
    virtual vtkSmartPointer<vtkRenderer> getRender() = 0;
    virtual void reFreash() = 0;
    virtual vtkSmartPointer<vtkRenderWindowInteractor> getInteractor() = 0;
    virtual vtkSmartPointer<vtkRenderWindow> getrenderWindow() = 0;
//    virtual void test() = 0;
};
#endif // VISUALWIDGETSERVICE_H
